SystemOrganization addCategory: #'CodeModel-Environment'!
SystemOrganization addCategory: #'CodeModel-Iterators'!
SystemOrganization addCategory: #'CodeModel-Model'!
SystemOrganization addCategory: #'CodeModel-Parser'!
SystemOrganization addCategory: #'CodeModel-Notification'!
SystemOrganization addCategory: #'CodeModel-Tests'!
SystemOrganization addCategory: #'CodeModel-Utilities'!

SmaCCParser subclass: #CMParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMParser commentStamp: 'cwp 6/15/2004 10:49' prior: 0!
A parser for Squeak methods that produces an AST of CMNodes.

One point of incompatibility with the old Squeak parser: Negative numbers must not have whitespace after the minus sign. That is, '0 @ - 1' is legal with Parser, but will raise a parse error with CMParser. '0 @ -1' works fine in both parsers.

!

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 09:54'!
methodSeqWithTemps: nodes
	"Annotations | TemporaryVariables | Annotations Statements"

	^ Array
		with: nodes first, nodes fifth
		with: (self sequenceWithTemps: {{nodes second. nodes third. nodes fourth}. nodes sixth})
! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
value: nodes

	^ nodes first value! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:46'!
litChar: nodes

	^ CMLiteral
		token: nodes first asTreeToken
		value: (nodes first value at: 2)! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:08'!
firstIn: nodes
	^ OrderedCollection with: nodes first! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:49'!
method: nodes
	^ CMMethod
		selectorParts: (nodes first first collect: [:ea | ea asTreeToken])
		arguments: nodes first second
		annotations: nodes second first
		body: nodes second second! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 6/15/2004 13:03'!
startingStateForMethod
	^1! !

!CMParser class methodsFor: 'generated-accessing' stamp: 'cwp 6/15/2004 13:03'!
scannerClass
	^CMScanner! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:41'!
blockWithArgs: nodes

	^ (CMBlock
		arguments: nodes second
		body: nodes fourth)
			leftBracket: nodes first asTreeToken
			rightBracket: nodes fifth asTreeToken;
			bar: nodes third! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 6/15/2004 13:03'!
startingStateForMethodPattern
	^2! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:38'!
expressionAdd: nodes
	| tokens |
	tokens _ nodes first.
	tokens 
		add: nodes second;
		add: nodes third.
	^ tokens! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:44'!
colonAdd: nodes
	nodes second colon: nodes first asTreeToken.
	^ OrderedCollection with: nodes second! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:46'!
litFalse: nodes

	^ CMLiteral
		token: nodes first asTreeToken
		value: false! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 11:50'!
sequence: nodes
	^ self 
		divideStatements: nodes first
		in: [:s :p | CMSequence statements: s periods: p]! !

!CMParser methodsFor: 'generated-tables' stamp: 'cwp 6/15/2004 13:03'!
transitionTable
	^#(
#(3 21 23 25 24 29 26 33 47 37 62 41 70)
#(3 21 23 25 24 29 26 45 62 41 70)
#(3 49 2 53 3 57 5 61 6 65 7 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 48 149 49 153 50 157 51 161 52 165 61 186 67 169 71)
#(3 286 10 173 60 286 67)
#(2 306 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 31 67)
#(3 177 23 181 59)
#(3 177 23 185 59)
#(2 0 67)
#(3 286 2 286 3 286 5 286 6 286 7 286 10 286 11 286 12 286 15 286 16 286 17 286 20 286 21 286 22 286 23 286 31 189 58 193 60 286 67)
#(3 314 2 314 3 314 5 314 6 314 7 314 10 314 11 314 12 314 15 314 16 314 17 314 20 314 21 314 22 314 23 197 24 314 31 314 67)
#(2 0 67)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 201 40 125 42 129 43 133 44 137 45 141 46 145 48 153 50 157 51 161 52)
#(3 205 5 209 17 213 22 217 23 221 24 225 25 229 26 233 28)
#(3 49 2 53 3 57 5 61 6 65 7 186 9 69 11 73 12 237 13 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 38 121 40 241 41 125 42 129 43 133 44 137 45 141 46 145 48 149 49 153 50 157 51 161 52 245 61 169 71)
#(2 398 2 3 5 9 11 12 15 16 17 20 21 22 23 31 67)
#(3 370 7 370 23 249 66)
#(2 14 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 18 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 22 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(3 49 2 53 3 57 5 69 11 73 12 186 14 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 48 253 49 153 50 157 51 161 52)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 257 40 125 42 129 43 133 44 137 45 141 46 145 48 153 50 157 51 161 52)
#(2 26 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 30 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 38 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 78 1 7 9 14 18 19 23 24 26 27 67)
#(2 34 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 158 1 9 14 18 19 23 24 26 67)
#(3 162 1 162 9 162 14 162 18 162 23 162 24 162 26 261 27 162 67)
#(3 265 1 90 9 90 14 269 39 90 67)
#(2 82 1 9 14 67)
#(2 154 1 9 14 18 19 23 24 26 67)
#(2 98 1 9 14 18 67)
#(3 102 1 102 9 102 14 102 18 273 19 102 67)
#(3 106 1 106 9 106 14 106 18 277 23 281 24 285 26 289 53 293 54 297 55 106 67)
#(2 150 1 9 14 18 19 23 24 26 67)
#(2 138 1 9 14 18 19 67)
#(2 298 9 67)
#(2 174 1 9 14 18 19 67)
#(3 178 1 178 9 178 14 178 18 178 19 281 24 285 26 301 54 305 55 178 67)
#(3 182 1 182 9 182 14 182 18 182 19 277 23 281 24 285 26 309 53 313 54 317 55 182 67)
#(2 0 67)
#(3 49 2 53 3 57 5 186 9 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 48 321 49 153 50 157 51 161 52 186 67)
#(3 325 10 0 67)
#(2 282 2 3 5 6 7 9 10 11 12 13 15 16 17 20 21 22 23 24 31 67)
#(2 390 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 24 31 67)
#(2 310 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 31 67)
#(2 170 67)
#(3 49 2 53 3 57 5 329 6 333 7 325 10 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 48 337 49 153 50 157 51 161 52 186 67)
#(3 177 23 341 59)
#(3 345 1 90 9 90 14 349 39 90 67)
#(3 318 9 318 20 353 63)
#(3 326 3 326 5 326 11 326 12 326 15 326 17 326 18 326 20 326 21 326 22 326 23 326 24 326 25 326 26 326 28 326 31 326 33 357 64)
#(2 42 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 46 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 54 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 58 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 50 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 62 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(3 177 23 361 59)
#(3 365 6 369 7 373 9 377 13)
#(2 381 9)
#(3 385 7 101 23 389 37)
#(2 393 14)
#(2 397 18)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 401 40 125 42 129 43 133 44 137 45 141 46 145 48 153 50 157 51 161 52)
#(3 405 2 53 3 57 5 94 9 69 11 73 12 94 14 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 409 40 125 42 129 43 133 44 137 45 141 46 145 48 153 50 157 51 161 52 94 67)
#(2 190 9 14 67)
#(3 277 23 281 24 285 26 413 53 417 54 421 55 425 69)
#(2 234 1 9 14 18 19 23 24 26 67)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 429 37 125 42 433 45 141 46 437 51 441 52 445 56)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 429 37 125 42 449 45 141 46 453 52 457 57)
#(2 230 1 9 14 18 19 23 24 26 67)
#(2 222 1 9 14 18 19 24 26 67)
#(3 210 1 210 9 210 14 210 18 210 19 461 24 210 67)
#(2 214 1 9 14 18 19 24 26 67)
#(3 202 1 202 9 202 14 202 18 202 19 461 24 202 67)
#(2 226 1 9 14 18 19 23 24 26 67)
#(2 218 1 9 14 18 19 24 26 67)
#(3 206 1 206 9 206 14 206 18 206 19 461 24 206 67)
#(2 302 9 67)
#(3 465 24 469 34)
#(3 286 2 286 3 286 5 286 10 286 11 286 12 286 15 286 16 286 17 286 20 286 21 286 22 286 23 286 31 473 60 286 67)
#(3 370 7 370 23 477 66)
#(2 270 67)
#(2 394 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 24 31 67)
#(2 94 9 14 67)
#(2 198 9 14 67)
#(3 481 9 485 20)
#(3 53 3 489 5 69 11 73 12 77 15 493 17 497 18 89 20 93 21 97 22 501 23 505 24 509 25 513 26 517 28 105 31 521 33 525 35 529 65)
#(2 110 6 7 9 13)
#(3 370 7 370 23 533 66)
#(3 49 2 53 3 57 5 61 6 65 7 186 9 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 48 149 49 153 50 157 51 161 52 537 61 169 71)
#(2 126 1 9 14 18 19 23 24 26 67)
#(3 177 23 541 59)
#(2 122 1 9 14 18 19 23 24 26 67)
#(2 402 2 3 5 9 11 12 15 16 17 20 21 22 23 31 67)
#(2 374 7 23)
#(2 166 1 9 14 18 19 23 24 26 67)
#(2 146 1 9 14 18 19 23 24 26 67)
#(2 134 1 9 14 18 67)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 545 40 125 42 129 43 133 44 137 45 141 46 145 48 153 50 157 51 161 52)
#(2 86 1 9 14 67)
#(2 378 1 9 14 18 19 67)
#(2 382 1 9 14 18 19 67)
#(3 386 1 386 9 386 14 386 18 386 19 461 24 386 67)
#(2 142 1 9 14 18 19 67)
#(2 162 1 9 14 18 19 23 24 26 67)
#(3 258 1 258 9 258 14 258 18 258 19 277 23 258 24 285 26 289 53 293 54 258 67)
#(3 250 1 250 9 250 14 250 18 250 19 250 24 285 26 301 54 250 67)
#(3 254 1 254 9 254 14 254 18 254 19 277 23 254 24 285 26 309 53 313 54 254 67)
#(2 242 1 9 14 18 19 24 67)
#(3 266 1 266 9 266 14 266 18 266 19 277 23 266 24 266 26 289 53 266 67)
#(3 262 1 262 9 262 14 262 18 262 19 277 23 262 24 262 26 309 53 262 67)
#(2 238 1 9 14 18 19 24 26 67)
#(3 53 3 57 5 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 429 37 125 42 433 45 141 46 437 51 441 52 549 56)
#(3 53 3 69 11 73 12 77 15 89 20 93 21 97 22 105 31 553 35)
#(3 557 4 561 8 565 24)
#(3 49 2 53 3 57 5 325 10 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 48 569 49 153 50 157 51 161 52 186 67)
#(3 573 7 101 23 389 37)
#(2 66 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 322 9 20)
#(3 318 9 318 20 577 63)
#(3 326 3 326 5 326 11 326 12 326 15 326 17 326 18 326 20 326 21 326 22 326 23 326 24 326 25 326 26 326 28 326 31 326 33 581 64)
#(2 70 1 3 4 5 8 9 11 12 14 15 17 18 19 20 21 22 23 24 25 26 28 31 33 67)
#(2 338 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(2 346 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(2 350 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(2 342 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(2 354 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(2 366 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(2 334 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(2 330 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(3 585 7 101 23 389 37)
#(2 589 9)
#(2 114 6 7 9 13)
#(3 345 1 90 9 90 14 593 39 90 67)
#(2 246 1 9 14 18 19 24 67)
#(2 6 4 8 24)
#(2 290 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 31 67)
#(3 465 24 597 34)
#(3 53 3 69 11 73 12 77 15 89 20 93 21 97 22 105 31 601 35)
#(2 274 67)
#(3 286 2 286 3 286 5 286 10 286 11 286 12 286 15 286 16 286 17 286 20 286 21 286 22 286 23 286 31 605 60 286 67)
#(3 609 9 485 20)
#(3 53 3 489 5 69 11 73 12 77 15 493 17 613 18 89 20 93 21 97 22 501 23 505 24 509 25 513 26 517 28 105 31 521 33 525 35 529 65)
#(3 49 2 53 3 57 5 186 9 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 48 617 49 153 50 157 51 161 52)
#(2 118 1 9 14 18 19 23 24 26 67)
#(2 194 9 14 67)
#(3 621 4 565 24)
#(2 10 4 8 24)
#(3 49 2 53 3 57 5 325 10 69 11 73 12 77 15 81 16 85 17 89 20 93 21 97 22 101 23 105 31 109 35 113 37 117 38 121 40 125 42 129 43 133 44 137 45 141 46 145 48 625 49 153 50 157 51 161 52 186 67)
#(2 362 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(2 358 3 5 11 12 15 17 18 20 21 22 23 24 25 26 28 31 33)
#(2 629 9)
#(2 294 2 3 5 6 7 10 11 12 15 16 17 20 21 22 23 31 67)
#(2 278 67)
#(2 130 1 9 14 18 19 23 24 26 67)
)! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/28/2004 14:36'!
unaryMethodPattern: nodes
	^ Array 
		with: (Array with: nodes first)
		with: #()
		! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 15:39'!
parenthesize: nodes
	nodes second leftParen: nodes first rightParen: nodes third.
	^ nodes second! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:40'!
assignment: nodes

	^ CMAssignment
		variable: nodes first 
		operator: nodes second asTreeToken
		value: nodes third ! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:51'!
variable: nodes

	^ CMVariableReference new
		identifier: nodes first asTreeToken ! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
unaryMessage: nodes

	^ {{nodes first}. #()}! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
addMessagePart: nodes

	^ {nodes first first copyWith: nodes second.
	   nodes first second copyWith: nodes third}! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
streamPut: nodes

	^ nodes first
		nextPut: nodes second;
		yourself! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 23:47'!
doubleAnnotation: nodes
	"Annotations < KeywordMessage >	< KeywordMessage >"
		
	| result |
	result _ self addAnnotation: {nodes first. nodes second. nodes third. nodes fourth firstChar}.
	^ self addAnnotation: {result. nodes fourth secondChar. nodes fifth. nodes sixth}.
	
	! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/25/2004 14:38'!
argumentAdd: nodes
	| arguments |
	arguments _ nodes first.
	arguments add: nodes third.
	arguments last colon: nodes second.
	^ arguments! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/28/2004 21:59'!
twoArrays: nodes

	^ Array
		with: (Array with: nodes first)
		with: (Array with: nodes second)
! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:39'!
array: nodes
	^ self 
		divideStatements: nodes second
		in: [:s :p | (CMArray statements: s periods: p)
						leftBrace: nodes first asTreeToken
						rightBrace: nodes third asTreeToken]! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:38'!
argument: nodes
	^ CMArgument identifier: nodes first asTreeToken! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:38'!
addAnnotation: nodes
	"Annotations < KeywordMessage >	"
		
	 nodes first add: ((CMAnnotation 
						selectorParts: (nodes third first collect: [:ea | ea asTreeToken]) 
						arguments: nodes third second)
							leftParen: nodes second asTreeToken
							rightParen: nodes fourth asTreeToken).
	^ nodes first

			! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:46'!
litNil: nodes

	^ CMLiteral
		token: nodes first asTreeToken
		value: nil! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:47'!
litStringSymbol: nodes

	| s |
	s _ nodes second value.
	^ CMLiteral
		token: nodes second asTreeToken
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''') asSymbol! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
array

	^ #()! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 5/23/2004 22:44'!
parseMethod: aString
	^ self parse: aString startingAt: self startingStateForMethod ! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:47'!
litSymbol: nodes

	^ CMLiteral
		token: nodes second asTreeToken
		value: nodes second value asSymbol! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:50'!
return: nodes
	| statement |
	statement _ Array new: nodes size - 1.
	statement at: 1 put: (CMReturn return: nodes first asTreeToken  value: nodes second).
	nodes size = 3 ifTrue: [statement at: 2 put: nodes third].
	^ statement! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
messagePart: nodes

	^ {{nodes first}. {nodes second}}! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:50'!
returnAdd: nodes
	| statements |
	statements _ nodes first.
	statements add: nodes second.
	statements add: (CMReturn return: nodes third asTreeToken value: nodes fourth).
	nodes size > 4 ifTrue: [statements add: nodes fifth].
	^ statements! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/28/2004 14:46'!
empty
	^ OrderedCollection new! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:40'!
blockArgs: nodes

	^ (CMBlock
		arguments: nodes second
		body: (CMSequence statements: #() periods: #()))
					leftBracket: nodes first asTreeToken
					rightBracket: nodes third asTreeToken! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:47'!
litString: nodes

	| s |
	s _ nodes first value.
	^ CMLiteral
		token: nodes first asTreeToken
		value: ((s copyFrom: 2 to: s size - 1)
				copyReplaceAll: '''''' with: '''')! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
byteStream

	^ ByteArray new writeStream! !

!CMParser methodsFor: 'parsing' stamp: 'cwp 5/29/2004 11:35'!
actionForCurrentToken
	| ids action |
	ids := currentToken id.
	1 to: ids size
		do: 
			[:i | 
			action := self actionFor: (ids at: i).
			(action bitAnd: self actionMask) = self errorAction ifFalse: [^action].
			(ids at: i) = scanner negativeNumberId 
				ifTrue: 
					[currentToken := CMParseToken 
										id: (Array with: scanner binarySymbolId)
										whitespace: currentToken whitespace
										start: currentToken startPosition
										value: '-'.
					scanner position: currentToken stopPosition - 1.
					^self actionForCurrentToken]].
	^self errorAction! !

!CMParser methodsFor: 'generated-tables' stamp: 'cwp 6/15/2004 13:03'!
reduceTable
	^#(
#(34 2 #messagePart:)
#(34 3 #addMessagePart:)
#(35 1 #litTrue:)
#(35 1 #litFalse:)
#(35 1 #litNil:)
#(35 1 #litNumber:)
#(35 1 #litNumber:)
#(35 1 #litChar:)
#(35 1 #litString:)
#(35 2 #litStringSymbol:)
#(35 2 #litSymbol:)
#(35 2 #litSymbol:)
#(35 2 #litSymbol:)
#(35 2 #litSymbol:)
#(35 2 #litSymbol:)
#(35 4 #litArray:)
#(35 4 #litArray:)
#(36 1 #reduceFor:)
#(37 1 #variable:)
#(38 1 #firstIn:)
#(38 3 #expressionAdd:)
#(39 0 #reduceActionForOptionalXXXXX1:)
#(39 1 #reduceActionForOptionalXXXXX2:)
#(40 1 #first:)
#(40 1 #first:)
#(40 1 #first:)
#(41 2 #colonAdd:)
#(41 3 #argumentAdd:)
#(42 5 #blockWithArgs:)
#(42 3 #blockNoArgs:)
#(42 3 #blockArgs:)
#(42 7 #blockWithTemps:)
#(43 3 #assignment:)
#(44 1 #first:)
#(44 3 #cascade:)
#(45 3 #parenthesize:)
#(45 1 #first:)
#(45 1 #first:)
#(45 1 #first:)
#(45 1 #first:)
#(46 3 #array:)
#(47 2 #method:)
#(48 1 #first:)
#(48 1 #first:)
#(48 1 #first:)
#(49 0 #reduceFor:)
#(49 2 #reduceFor:)
#(49 5 #returnAdd:)
#(49 3 #return:)
#(50 2 #messageSend:)
#(50 2 #messageSend:)
#(50 2 #messageSend:)
#(51 2 #messageSend:)
#(51 2 #messageSend:)
#(51 2 #messageSend:)
#(52 2 #messageSend:)
#(52 2 #messageSend:)
#(53 1 #unaryMessage:)
#(54 2 #messagePart:)
#(55 2 #messagePart:)
#(55 3 #addMessagePart:)
#(56 1 #first:)
#(56 1 #first:)
#(56 1 #first:)
#(57 1 #first:)
#(57 1 #first:)
#(58 2 #methodSequence:)
#(58 4 #methodSeqEmptyTemps:)
#(58 6 #methodSeqWithTemps:)
#(59 1 #argument:)
#(60 0 #empty)
#(60 4 #addAnnotation:)
#(60 6 #doubleAnnotation:)
#(61 1 #sequence:)
#(61 2 #sequenceWithTemps:)
#(62 1 #unaryMethodPattern:)
#(62 2 #twoArrays:)
#(62 1 #first:)
#(63 0 #byteStream)
#(63 2 #byteStreamPut:)
#(64 0 #stream)
#(64 2 #streamPut:)
#(65 1 #value:)
#(65 1 #valueSymbol:)
#(65 1 #valueSymbol:)
#(65 1 #valueSymbol:)
#(65 1 #valueSymbol:)
#(65 1 #valueSymbol:)
#(65 3 #contents2:)
#(65 3 #contents2:)
#(65 1 #valueSymbol:)
#(66 0 #array)
#(66 2 #add:)
#(69 1 #first:)
#(69 1 #first:)
#(69 1 #first:)
#(70 2 #messagePart:)
#(70 3 #addMessagePart:)
#(71 1 #reduceFor:)
#(71 3 #reduceFor:)
)! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
add: nodes

	^ nodes first copyWith: nodes second! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 6/15/2004 13:14'!
litNumber: nodes

	| str num |
	str _ (nodes first value copyWithout: $ ) readStream.
	num _ Number readFrom: str.
	str atEnd ifFalse: [
		currentToken _ nil.
		scanner position: scanner position - (str originalContents size - str position) + 1.
		self reportErrorMessage: 'Digit out of range'].
	^ CMLiteral token: nodes first asTreeToken value: num! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:44'!
cascade: nodes
	| cascade |
	(nodes first isKindOf: CMMessage)
		ifTrue: [cascade _ (CMCascade message: nodes first)]
		ifFalse: [cascade _ nodes first].
	cascade
		addMessage: (CMMessage
						receiver: cascade messages first receiver
						selectorParts: (nodes third first collect: [:ea | ea asTreeToken])
						arguments: nodes third last)
		semicolon: nodes second asTreeToken.
	^ cascade! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:50'!
sequenceWithTemps: nodes
	^ self 
		divideStatements: nodes second
		in: [:s :p | (CMSequence temporaries: nodes first second statements: s periods: p)
						leftBar: nodes first first asTreeToken 
						rightBar: nodes first third asTreeToken]! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:45'!
litArray: nodes
	| token |
	token _ String streamContents: [:stream |
						stream 
							nextPutAll: nodes first value;
							nextPutAll: nodes second value.
						nodes third contents do: [:ea | stream nextPutAll: ea asString]
											separatedBy: [stream nextPut: $ ].
						stream nextPutAll: nodes fourth value].				
	^ CMLiteral
		token: (CMToken whitespace: nodes first whitespace value: token)
		value: nodes third contents! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
byteStreamPut: nodes

	^ nodes first
		nextPut: nodes second value asNumber;
		yourself! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:48'!
litTrue: nodes

	^ CMLiteral
		token: nodes first asTreeToken
		value: true! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
contents2: nodes

	^ nodes second contents! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 23:41'!
blockWithTemps: nodes
	"This production rule ensures that '[:arg || temp | statement]' will parse correctly. It's
	necessary because the scanner treats the '||' as a single token - necessary for binary
	selectors. So here we manually split it up into two tokens, and pass the nodes along
	to the ordinary production rules."
	
	| left right subset body |
	left _ nodes third firstChar.
	right _ nodes third secondChar.
	
	"create the node structure that #sequenceWithTemps expects"
	subset _ OrderedCollection new.
	subset 
		add: right;
		add: nodes fourth;
		add: nodes fifth.
	subset _ OrderedCollection with: subset.
	subset add: nodes sixth.
	body _ self sequenceWithTemps: subset.
	
	"create the node structure that #blockWithArgs: expects"
	subset _ nodes first: 2.
	subset 
		add: left;
		add: body;
		add: nodes seventh.
	
	^ self blockWithArgs: subset
! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 6/5/2004 21:03'!
parseExpression: aString onError: aBlock
	^ [self parseExpression: aString]
		on: SmaCCParserError
		do: aBlock! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 23:16'!
methodSequence: nodes
	nodes at: 2 put: (self 
						divideStatements: nodes second 
						in: [:s :p | CMSequence statements: s periods: p]).
	^ nodes! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 6/15/2004 13:03'!
startingStateForAnnotations
	^4! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:49'!
primitiveMessage: nodes
	^ (CMAnnotation 
		selectorParts: (nodes second first collect: [:ea | ea asTreeToken])
		arguments: nodes second second)
			leftParen: nodes first rightParen: nodes third! !

!CMParser methodsFor: 'generated-reduction actions' stamp: 'cwp 6/15/2004 13:03'!
reduceActionForOptionalXXXXX2: nodes 
	^nodes at: 1! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 5/24/2004 13:46'!
parseExpression: aString
	^ self parse: aString startingAt: self startingStateForSequence! !

!CMParser class methodsFor: 'generated-comments' stamp: 'cwp 6/15/2004 13:03'!
parserDefinitionComment

	"%id <name> <negativeNumber> <binarySymbol>;
%start MethodPattern Sequence Annotations;

Method:
	MethodPattern MethodSequence				{#method:};

MethodPattern:
	<name>										{#unaryMethodPattern:}
|	<binarySymbol> Argument 					{#twoArrays:}
|	KeywordMethodPattern 						{#first:};

KeywordMethodPattern:
	<keyword> Argument							{#messagePart:}
|	KeywordMethodPattern <keyword> Argument	{#addMessagePart:};

MethodSequence:
	Annotations Statements						{#methodSequence:}
|	Annotations ""||"" Annotations Statements		{#methodSeqEmptyTemps:}
|	Annotations ""|"" TemporaryVariables ""|"" Annotations Statements {#methodSeqWithTemps:};

Annotations:
																{#empty}
|	Annotations ""<"" AnnotationMessage "">""						{#addAnnotation:}
|	Annotations ""<"" AnnotationMessage ""><"" AnnotationMessage "">""	{#doubleAnnotation:};

AnnotationMessage:
	<keyword> Literal											{#messagePart:}
|	AnnotationMessage <keyword> Literal							{#addMessagePart:};


Sequence:
	Statements													{#sequence:}
|	Temporaries Statements										{#sequenceWithTemps:};

Temporaries:
	""||""											
|	""|"" TemporaryVariables ""|"";

TemporaryVariables:
																{#array}
|	TemporaryVariables Variable								{#add:};
	
Statements:
												
|	StatementList "".""?							
|	StatementList ""."" ""^"" Expression "".""?							{#returnAdd:}
|	""^"" Expression "".""?											{#return:};

StatementList:
	Expression													{#firstIn:}
|	StatementList ""."" Expression									{#expressionAdd:};

Block:
	""["" BlockArgs ""|"" Sequence ""]""									{#blockWithArgs:}
|	""["" Sequence ""]""												{#blockNoArgs:}
|	""["" BlockArgs ""]""												{#blockArgs:}
|	""["" BlockArgs ""||"" TemporaryVariables ""|"" Statements ""]""			{#blockWithTemps:};

BlockArgs:
	"":"" Argument												{#colonAdd:}
|	BlockArgs "":"" Argument										{#argumentAdd:};

Expression:
	Assignment													{#first:}
|	Cascade														{#first:}
|	Primary													{#first:};

Primary:
	""("" Expression "")""												{#parenthesize:}
|	Array														{#first:}
|	Block														{#first:}
|	Literal														{#first:}
|	Variable													{#first:};

Assignment:
	Variable <assignment> Expression								{#assignment:};

Cascade:
	MessageSend												{#first:}
|	Cascade "";"" Message											{#cascade:};

MessageSend:
	KeywordMessageSend										{#first:}
|	BinaryMessageSend											{#first:}
|	UnaryMessageSend											{#first:};

Message:
	UnaryMessage												{#first:}
|	BinaryMessage												{#first:}
|	KeywordMessage											{#first:};

KeywordMessageSend:
	BinaryMessageSend KeywordMessage							{#messageSend:}
|	UnaryMessageSend KeywordMessage							{#messageSend:}
|	Primary KeywordMessage									{#messageSend:};

KeywordMessage:
	<keyword> KeywordArgument								{#messagePart:}
|	KeywordMessage <keyword> KeywordArgument				{#addMessagePart:};

KeywordArgument:
	BinaryMessageSend											{#first:}
|	UnaryMessageSend											{#first:}
|	Primary													{#first:};

BinaryMessageSend:
	BinaryMessageSend BinaryMessage							{#messageSend:}
|	UnaryMessageSend BinaryMessage							{#messageSend:}
|	Primary BinaryMessage										{#messageSend:};

BinaryMessage :
	<binarySymbol> BinaryArgument								{#messagePart:};

BinaryArgument:
	UnaryMessageSend											{#first:}
|	Primary													{#first:};
		
UnaryMessageSend :
	UnaryMessageSend UnaryMessage							{#messageSend:}
|	Primary UnaryMessage										{#messageSend:};

UnaryMessage :
	<name>														{#unaryMessage:};

Array:
	""{"" Statements ""}""												{#array:};

Variable: 
	<name>														{#variable:};

Argument:
	<name>														{#argument:};

Literal:
	""true""														{#litTrue:}
|	""false""														{#litFalse:}
|	""nil""														{#litNil:}
|	<number>													{#litNumber:}
|	<negativeNumber>											{#litNumber:} 
|	<character>													{#litChar:}
|	<string>														{#litString:}
|	""#"" <string>													{#litStringSymbol:}
|	""#"" <name>													{#litSymbol:}
|	""#"" <binarySymbol>											{#litSymbol:}
|	""#"" <keyword>												{#litSymbol:}
|	""#"" <multikeyword>											{#litSymbol:}
|	""#"" <alternateKeyword>										{#litSymbol:}
|	""#"" ""["" ByteArray ""]""											{#litArray:}
|	""#"" ""("" LiteralArray "")""										{#litArray:};

ByteArray:
																{#byteStream}
|	ByteArray <number>											{#byteStreamPut:};

LiteralArray:
																{#stream}
|	LiteralArray ArrayLiteral									{#streamPut:};

ArrayLiteral:
	Literal														{#value:}
|	<name>														{#valueSymbol:}
|	<binarySymbol>												{#valueSymbol:}
|	<keyword>													{#valueSymbol:}
|	<multikeyword>												{#valueSymbol:}
|	<alternateKeyword>											{#valueSymbol:}
|	""("" LiteralArray "")""											{#contents2:}
|	""["" ByteArray ""]""											{#contents2:}
|	<anyChar>													{#valueSymbol:};

"! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:40'!
blockNoArgs: nodes

	^ (CMBlock
		body: nodes second)
			leftBracket: nodes first asTreeToken
			rightBracket: nodes third asTreeToken
		! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 5/26/2004 11:53'!
parseAnnotations: aString
	^ self parse: aString startingAt: self startingStateForAnnotations! !

!CMParser class methodsFor: 'generated-comments' stamp: 'cwp 6/15/2004 13:03'!
symbolComment

	"
1. "".""
2. ""^""
3. ""#""
4. "">""
5. ""[""
6. ""||""
7. ""|""
8. ""><""
9. ""]""
10. ""<""
11. ""true""
12. ""false""
13. "":""
14. ""}""
15. ""nil""
16. ""{""
17. ""(""
18. "")""
19. "";""
20. <number>
21. <negativeNumber>
22. <string>
23. <name>
24. <keyword>
25. <multikeyword>
26. <binarySymbol>
27. <assignment>
28. <alternateKeyword>
29. <whitespace>
30. <comment>
31. <character>
32. <variableAssignment>
33. <anyChar>
34. AnnotationMessage
35. Literal
36. B e g i n
37. Variable
38. StatementList
39. Optional: "".""
40. Expression
41. BlockArgs
42. Block
43. Assignment
44. Cascade
45. Primary
46. Array
47. Method
48. MessageSend
49. Statements
50. KeywordMessageSend
51. BinaryMessageSend
52. UnaryMessageSend
53. UnaryMessage
54. BinaryMessage
55. KeywordMessage
56. KeywordArgument
57. BinaryArgument
58. MethodSequence
59. Argument
60. Annotations
61. Sequence
62. MethodPattern
63. ByteArray
64. LiteralArray
65. ArrayLiteral
66. TemporaryVariables
67. E O F
68. error
69. Message
70. KeywordMethodPattern
71. Temporaries
"! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
stream

	^ Array new writeStream! !

!CMParser methodsFor: 'private' stamp: 'cwp 5/25/2004 11:45'!
divideStatements: aCollection in: aBlock
	| statements periods |
	statements _ OrderedCollection new.
	periods _ OrderedCollection new.
	aCollection pairsDo: [:s :p | statements add: s. p ifNotNil: [periods add: p]].
	^ aBlock value: statements value: periods
	! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/30/2004 00:48'!
messageSend: nodes

	^ CMMessage
		receiver: nodes first
		selectorParts: (nodes second first collect: [:ea | ea asTreeToken])
		arguments: nodes second last! !

!CMParser methodsFor: 'generated-reduction actions' stamp: 'cwp 6/15/2004 13:03'!
reduceActionForOptionalXXXXX1: nodes 
	^nil! !

!CMParser class methodsFor: 'generated-starting states' stamp: 'cwp 6/15/2004 13:03'!
startingStateForSequence
	^3! !

!CMParser class methodsFor: 'parsing' stamp: 'cwp 6/5/2004 21:47'!
parseMethod: aString onError: aBlock
	^ [self parseMethod: aString]
		on: SmaCCParserError
		do: aBlock! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
first: nodes

	^ nodes first! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/29/2004 23:42'!
methodSeqEmptyTemps: nodes
	"Annotations || Annotations Statements"	

	| left right |
	left _ nodes second firstChar.
	right _ nodes second secondChar.
	
	^ self methodSeqWithTemps: {nodes first. left. OrderedCollection new. right. nodes third. nodes fourth} ! !

!CMParser methodsFor: 'reduction actions' stamp: 'cwp 5/24/2004 12:27'!
valueSymbol: nodes

	^ nodes first value asSymbol! !

SmaCCScanner subclass: #CMScanner
	instanceVariableNames: 'whitespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMScanner commentStamp: 'cwp 6/15/2004 10:51' prior: 0!
A scanner for use with CMParser.

One point of incompatibility with the existing Squeak scanner: selectors are not allowed to have empty keywords. That is: 'keyword::' will scan as one token in Scanner, but two tokens in CMScanner.!

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 6/15/2004 13:03'!
emptySymbolTokenId
	^67! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan8
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			currentCharacter == $e ifTrue: [^self scan1].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan6
	
	[self step.
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(28).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan6].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan1
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $- 
		ifTrue: 
			[self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(20).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan3
	
	[self step.
	currentCharacter ~~ $'] whileTrue.
	^self scan4! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/25/2004 02:19'!
flushWhitespace
	| answer |
	answer _ whitespace.
	whitespace _ String new.
	^ answer! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan4
	self recordMatch: #(22).
	self step.
	currentCharacter == $' ifTrue: [^self scan3].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 6/15/2004 13:03'!
nameId
	^23! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 6/15/2004 12:12'!
variableAssignment
	outputStream skip: -2.
	stream skip: -2.
	matchActions _ (Array with: self nameId).
	self createTokenFor: outputStream contents! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan2
	self step.
	currentCharacter isDigit 
		ifTrue: 
			[
			[self recordMatch: #(21).
			self step.
			currentCharacter isDigit] 
					whileTrue.
			^self reportLastMatch].
	currentCharacter == $- 
		ifTrue: 
			[self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(21).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scanForToken
	self step.
	(currentCharacter <= $ or: 
			[(currentCharacter between: $ and: $) 
				or: [currentCharacter == $` or: [currentCharacter >= $]]]) 
		ifTrue: [^self recordAndReportMatch: #(33)].
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) 
			ifTrue: 
				[self recordMatch: #(23 33).
				self step.
				(currentCharacter isDigit or: 
						[(currentCharacter between: $A and: $Z) 
							or: [currentCharacter between: $a and: $z]]) 
					ifTrue: 
						[
						[self recordMatch: #(23).
						self step.
						currentCharacter isDigit or: 
								[(currentCharacter between: $A and: $Z) 
									or: [currentCharacter between: $a and: $z]]] 
								whileTrue.
						currentCharacter == $: ifTrue: [^self scan10].
						^self reportLastMatch].
				currentCharacter == $: ifTrue: [^self scan10].
				^self reportLastMatch].
	(currentCharacter == $!! or: 
			[(currentCharacter between: $% and: $&) or: 
					[(currentCharacter between: $* and: $,) or: 
							[currentCharacter == $/ or: 
									[currentCharacter == $= or: 
											[(currentCharacter between: $? and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]]) 
		ifTrue: 
			[self recordMatch: #(26 33).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter isDigit 
		ifTrue: 
			[self recordMatch: #(20 33).
			self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(20).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $. ifTrue: [^self scan8].
					currentCharacter == $e ifTrue: [^self scan1].
					currentCharacter == $r ifTrue: [^self scan7].
					^self reportLastMatch].
			currentCharacter == $. ifTrue: [^self scan8].
			currentCharacter == $e ifTrue: [^self scan1].
			currentCharacter == $r ifTrue: [^self scan7].
			^self reportLastMatch].
	(currentCharacter isSeparator or: [currentCharacter == $]) 
		ifTrue: 
			[self recordMatch: #whitespace.
			self step.
			(currentCharacter isSeparator or: [currentCharacter == $]) 
				ifTrue: 
					[
					[self recordMatch: #whitespace.
					self step.
					currentCharacter isSeparator or: [currentCharacter == $]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $" 
		ifTrue: 
			[self recordMatch: #(33).
			self step.
			currentCharacter ~~ $" 
				ifTrue: 
					[
					[self step.
					currentCharacter ~~ $"] whileTrue.
					^self recordAndReportMatch: #comment].
			currentCharacter == $" ifTrue: [^self recordAndReportMatch: #comment].
			^self reportLastMatch].
	currentCharacter == $# ifTrue: [^self recordAndReportMatch: #(3 33)].
	currentCharacter == $$ 
		ifTrue: 
			[self recordMatch: #(33).
			self step.
			^self recordAndReportMatch: #(31)].
	currentCharacter == $' 
		ifTrue: 
			[self recordMatch: #(33).
			self step.
			currentCharacter ~~ $' ifTrue: [^self scan3].
			currentCharacter == $' ifTrue: [^self scan4].
			^self reportLastMatch].
	currentCharacter == $( ifTrue: [^self recordAndReportMatch: #(17 33)].
	currentCharacter == $) ifTrue: [^self recordAndReportMatch: #(18 33)].
	currentCharacter == $- 
		ifTrue: 
			[self recordMatch: #(26 33).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter isDigit ifTrue: [^self scan9].
			(currentCharacter isSeparator or: [currentCharacter == $]) 
				ifTrue: 
					[
					[self step.
					currentCharacter isDigit ifTrue: [^self scan9].
					currentCharacter isSeparator or: [currentCharacter == $]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $. ifTrue: [^self recordAndReportMatch: #(1 33)].
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(13 33).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan6].
			currentCharacter == $= ifTrue: [^self recordAndReportMatch: #(27)].
			^self reportLastMatch].
	currentCharacter == $; ifTrue: [^self recordAndReportMatch: #(19 33)].
	currentCharacter == $< 
		ifTrue: 
			[self recordMatch: #(10 26 33).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $> 
		ifTrue: 
			[self recordMatch: #(4 26 33).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $= and: $@) or: 
													[currentCharacter == $\ 
														or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter == $< 
				ifTrue: 
					[self recordMatch: #(8 26).
					self step.
					(currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
						ifTrue: 
							[
							[self recordMatch: #(26).
							self step.
							currentCharacter == $!! or: 
									[(currentCharacter between: $% and: $&) or: 
											[(currentCharacter between: $* and: $,) or: 
													[currentCharacter == $/ or: 
															[(currentCharacter between: $< and: $@) or: 
																	[currentCharacter == $\ 
																		or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
									whileTrue.
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $[ ifTrue: [^self recordAndReportMatch: #(5 33)].
	currentCharacter == $] ifTrue: [^self recordAndReportMatch: #(9 33)].
	currentCharacter == $^ ifTrue: [^self recordAndReportMatch: #(2 33)].
	currentCharacter == $_ ifTrue: [^self recordAndReportMatch: #(27 33)].
	currentCharacter == ${ ifTrue: [^self recordAndReportMatch: #(16 33)].
	currentCharacter == $| 
		ifTrue: 
			[self recordMatch: #(7 26 33).
			self step.
			(currentCharacter == $!! or: 
					[(currentCharacter between: $% and: $&) or: 
							[(currentCharacter between: $* and: $,) or: 
									[currentCharacter == $/ or: 
											[(currentCharacter between: $< and: $@) 
												or: [currentCharacter == $\ or: [currentCharacter == $~]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(26).
					self step.
					currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
							whileTrue.
					^self reportLastMatch].
			currentCharacter == $| 
				ifTrue: 
					[self recordMatch: #(6 26).
					self step.
					(currentCharacter == $!! or: 
							[(currentCharacter between: $% and: $&) or: 
									[(currentCharacter between: $* and: $,) or: 
											[currentCharacter == $/ or: 
													[(currentCharacter between: $< and: $@) or: 
															[currentCharacter == $\ 
																or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]) 
						ifTrue: 
							[
							[self recordMatch: #(26).
							self step.
							currentCharacter == $!! or: 
									[(currentCharacter between: $% and: $&) or: 
											[(currentCharacter between: $* and: $,) or: 
													[currentCharacter == $/ or: 
															[(currentCharacter between: $< and: $@) or: 
																	[currentCharacter == $\ 
																		or: [currentCharacter == $| or: [currentCharacter == $~]]]]]]]] 
									whileTrue.
							^self reportLastMatch].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $} ifTrue: [^self recordAndReportMatch: #(14 33)].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 6/15/2004 13:03'!
negativeNumberId
	^21! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan5
	
	[self step.
	currentCharacter isDigit or: 
			[(currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]]] 
			whileTrue.
	currentCharacter == $: 
		ifTrue: 
			[self recordMatch: #(25).
			self step.
			((currentCharacter between: $A and: $Z) 
				or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan5].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/25/2004 02:23'!
whitespace 
	whitespace := whitespace, outputStream contents.

	self resetScanner.
	self scanForToken! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan10
	self recordMatch: #(24).
	self step.
	((currentCharacter between: $A and: $Z) 
		or: [currentCharacter between: $a and: $z]) ifTrue: [^self scan5].
	currentCharacter == $= 
		ifTrue: [^self recordAndReportMatch: #variableAssignment].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 6/15/2004 13:03'!
errorTokenId
	^68! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/29/2004 11:38'!
scannerError
	(stream atEnd and: [start == (stream position + 1)]) 
		ifTrue: 
			[returnMatchBlock value: (CMParseToken 
										id: (Array with: self emptySymbolTokenId)
										whitespace: ''
										start: start
										value: '')].
	stream position: start - 1.
	returnMatchBlock value: (CMParseToken 
								id: #(0)
								whitespace: ''
								start: start
								value: (String with: stream next))
! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan9
	
	[self recordMatch: #(21).
	self step.
	currentCharacter isDigit] whileTrue.
	currentCharacter == $. 
		ifTrue: 
			[self step.
			currentCharacter isDigit 
				ifTrue: 
					[
					[self recordMatch: #(21).
					self step.
					currentCharacter isDigit] 
							whileTrue.
					currentCharacter == $e ifTrue: [^self scan2].
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $e ifTrue: [^self scan2].
	currentCharacter == $r 
		ifTrue: 
			[self step.
			(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
				ifTrue: 
					[
					[self recordMatch: #(21).
					self step.
					currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
							whileTrue.
					currentCharacter == $. 
						ifTrue: 
							[self step.
							(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
								ifTrue: 
									[
									[self recordMatch: #(21).
									self step.
									currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
											whileTrue.
									currentCharacter == $e ifTrue: [^self scan2].
									^self reportLastMatch].
							^self reportLastMatch].
					currentCharacter == $e ifTrue: [^self scan2].
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner methodsFor: 'generated-tokens' stamp: 'cwp 6/15/2004 13:03'!
binarySymbolId
	^26! !

!CMScanner methodsFor: 'initialize-release' stamp: 'cwp 5/24/2004 21:15'!
initialize
	super initialize.
	whitespace _ ''! !

!CMScanner class methodsFor: 'generated-comments' stamp: 'cwp 6/15/2004 13:03'!
scannerDefinitionComment

	"<decimalNumber>:	[0-9]+ (\. [0-9]+)? ;
<radixNumber>:		[0-9]+ r [0-9A-Z]+ (\. [0-9A-Z]+)? ;
<exponentNumber>:	(<decimalNumber> | <radixNumber>) e \-? [0-9]+ ;
<number>:			<decimalNumber> | <radixNumber> | <exponentNumber> ;
<negativeNumber>:	\- \s* <number> ;
<string>:				\'  [^\']* \' (\' [^\']* \')* ;
<name>:				[a-zA-Z] [a-zA-Z0-9]* ;
<keyword>:			<name> \: ;
<multikeyword>:		<name> \: (<name> \: )+ ;
<binarySymbol>:		[\~\-\!!\@\%\&\*\+\=\\\|\?\/\>\<\,] [\~\!!\@\%\&\*\+\=\\\|\?\/\>\<\,]* ;
<assignment>:		\: = | \_ ;
<alternateKeyword>:	\: <name> \: (<name> \:)* ;
<whitespace>:		\s+ ;
<comment>:			\"" [^\""]* \"" ;
<character>:			\$ . ;
<variableAssignment>:	<name> \: \= ;

<anyChar>:			. ; # For VW literal arrays that handle #(;) -> #(#';')

"! !

!CMScanner methodsFor: 'generated-scanner' stamp: 'cwp 6/15/2004 13:03'!
scan7
	self step.
	(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
		ifTrue: 
			[
			[self recordMatch: #(20).
			self step.
			currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
					whileTrue.
			currentCharacter == $. 
				ifTrue: 
					[self step.
					(currentCharacter isDigit or: [currentCharacter between: $A and: $Z]) 
						ifTrue: 
							[
							[self recordMatch: #(20).
							self step.
							currentCharacter isDigit or: [currentCharacter between: $A and: $Z]] 
									whileTrue.
							currentCharacter == $e ifTrue: [^self scan1].
							^self reportLastMatch].
					^self reportLastMatch].
			currentCharacter == $e ifTrue: [^self scan1].
			^self reportLastMatch].
	^self reportLastMatch! !

!CMScanner class methodsFor: 'generated-initialization' stamp: 'cwp 6/15/2004 13:03'!
initializeKeywordMap
	keywordMap := Dictionary new.
	#(#(23 'false' 12) #(23 'nil' 15) #(23 'true' 11)) do: 
			[:each | 
			(keywordMap at: each first ifAbsentPut: [Dictionary new]) at: (each at: 2)
				put: each last].
	^keywordMap! !

!CMScanner methodsFor: 'scanning' stamp: 'cwp 5/29/2004 11:35'!
createTokenFor: string 
	| token |
	token := CMParseToken
				id: matchActions
				whitespace: self flushWhitespace
				start: start
				value: string. 
	outputStream reset.
	matchActions := nil.
	returnMatchBlock value: token! !

Object subclass: #CMAbstractEvent
	instanceVariableNames: 'item requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Notification'!

!CMAbstractEvent methodsFor: 'testing' stamp: 'cwp 9/19/2004 18:22'!
isPruned
	^ false! !

!CMAbstractEvent methodsFor: 'triggering' stamp: 'cwp 8/19/2004 11:31'!
trigger: anEventManager
	anEventManager triggerEvent: self eventSelector with: self! !

!CMAbstractEvent methodsFor: 'accessing' stamp: 'cwp 8/19/2004 11:29'!
requestor
	^requestor! !

!CMAbstractEvent methodsFor: 'testing' stamp: 'cwp 8/20/2004 17:56'!
isModified
	^ false! !

CMAbstractEvent subclass: #CMAddedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Notification'!

!CMAddedEvent methodsFor: 'testing' stamp: 'cwp 8/19/2004 11:36'!
isAdded
	^ true! !

!CMAddedEvent class methodsFor: 'events-accessing' stamp: 'cwp 8/19/2004 17:55'!
changeKind
	^ #Added! !

!CMAbstractEvent class methodsFor: 'as yet unclassified' stamp: 'cwp 8/19/2004 11:29'!
item: aNode requestor: anObject
	^ self new item: aNode; requestor: anObject! !

CMAbstractEvent subclass: #CMModifiedEvent
	instanceVariableNames: 'oldItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Notification'!

!CMModifiedEvent class methodsFor: 'instance creation' stamp: 'cwp 8/20/2004 17:55'!
old: oldItem new: newItem requestor: anObject
	^ (self item: newItem requestor: anObject) oldItem: oldItem! !

!CMModifiedEvent methodsFor: 'testing' stamp: 'cwp 8/20/2004 17:56'!
isModified
	^ true! !

!CMModifiedEvent methodsFor: 'accessing' stamp: 'cwp 8/20/2004 17:55'!
oldItem: anObject
	oldItem := anObject! !

!CMModifiedEvent methodsFor: 'accessing' stamp: 'cwp 8/20/2004 17:55'!
oldItem
	^oldItem! !

!CMModifiedEvent class methodsFor: 'changeKinds' stamp: 'cwp 8/20/2004 17:58'!
changeKind
	^ #Modified! !

!CMAbstractEvent methodsFor: 'accessing' stamp: 'cwp 8/19/2004 11:29'!
requestor: anObject
	requestor := anObject! !

!CMAbstractEvent methodsFor: 'testing' stamp: 'cwp 8/19/2004 11:35'!
isAdded
	^ false! !

!CMAbstractEvent methodsFor: 'accessing' stamp: 'cwp 8/19/2004 11:28'!
item: anObject
	item := anObject! !

!CMAbstractEvent methodsFor: 'accessing' stamp: 'cwp 8/19/2004 17:14'!
eventSelector
	^ (item itemKind, self class changeKind) asSymbol! !

CMAbstractEvent subclass: #CMPrunedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Notification'!

!CMPrunedEvent methodsFor: 'testing' stamp: 'cwp 9/19/2004 18:22'!
isPruned
	^ true! !

!CMPrunedEvent class methodsFor: 'accessing' stamp: 'cwp 9/19/2004 18:27'!
changeKind
	^ #Pruned! !

!CMAbstractEvent methodsFor: 'accessing' stamp: 'cwp 8/19/2004 11:28'!
item
	^item! !

Object subclass: #CMPackageImporter
	instanceVariableNames: 'info package segment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Utilities'!

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 8/19/2004 18:53'!
annotateSegmentWithCategory: aCategory 
	segment category: aCategory! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 7/20/2004 13:45'!
importMethod: ref 
	| method category |
	method := CMParser 
				parseMethod: (ref actualClass sourceCodeAt: ref methodSymbol) asString 
						withSqueakLineEndings.
	category := ref actualClass organization 
				categoryOfElement: ref methodSymbol.
	self annotateMethod: method withCategory: category.
	ref timeStamp = '' 
		ifFalse: [self annotateMethod: method withTimestamp: ref timeStamp].
	segment addMethod: method! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 7/20/2004 13:45'!
importInstVar: name 
	segment addInstanceVariable: (CMInstanceVariable named: name)! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 8/14/2004 09:28'!
importPackage: aPackageInfo 
	| extensions |
	info := aPackageInfo.
	package := CMPackage named: info packageName.
	info classes do: [:ea | self importClass: ea].
	extensions _ Set new. 
	info extensionClasses do: [:ea | 
							extensions add: ea theNonMetaClass.
							extensions add: ea theMetaClass].
	extensions do: [:ea | self importExtension: ea].
	^package! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 7/20/2004 13:45'!
importClassInstVar: name 
	segment addClassInstanceVariable: (CMInstanceVariable named: name)! !

!CMPackageImporter class methodsFor: 'importing' stamp: 'cwp 5/20/2004 17:00'!
import: aPackageName
	^ self importFromPackageInfo: (PackageInfo named: aPackageName)! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 8/10/2004 11:34'!
importClass: aClass 
	| class |
	class := self nodeForClass: aClass.
	package addClass: class.
	segment := class core.
	aClass instVarNames do: [:ea | self importInstVar: ea].
	aClass classVarNames asSortedCollection 
		do: [:ea | self importClassVar: ea].
	aClass sharedPoolsString substrings do: [:ea | self importPoolImport: ea].
	self annotateSegmentWithComment: aClass organization classComment.
	self annotateSegmentWithCategory: aClass category.
	(info coreMethodsForClass: aClass) do: [:each | self importMethod: each].
	segment := class metacore.
	aClass class instVarNames do: [:ea | self importInstVar: ea].
	(info coreMethodsForClass: aClass class) 
		do: [:each | self importMethod: each].
	self annotateSegmentWithCategory: aClass category! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 6/3/2004 06:57'!
annotateMethod: method withCategory: aSymbol
	| category |
	aSymbol first = $*
		ifTrue: [category _ info starShortNameOf: aSymbol.
				category isEmpty 
					ifTrue: [category _ info methodCategoryPrefix allButFirst asSymbol]]
		ifFalse: [category _ aSymbol].
	method addAnnotation: (CMAnnotation 
								selector: #category: 
								argument: (CMLiteral for: category))! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 5/31/2004 12:17'!
annotateMethod: method withAuthor: aString

	method addAnnotation: (CMAnnotation 
								selector: #author: 
								argument: (CMLiteral for: aString))
! !

!CMPackageImporter methodsFor: 'accessing' stamp: 'cwp 5/20/2004 17:00'!
package: anObject
	package := anObject! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 7/20/2004 13:45'!
importClassVar: name 
	segment addClassVariable: (CMSharedVariable named: name)! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 5/31/2004 12:21'!
annotateMethod: method withTimestamp: aString
	| substrings |
	substrings _ aString substrings.
	
	self annotateMethod: method withAuthor: substrings first.
	self annotateMethod: method withDate: substrings second andTime: substrings third.
! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 7/20/2004 13:45'!
importPoolImport: name 
	segment addPoolImport: (CMPoolImport named: name)! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 7/19/2004 13:12'!
nodeForClass: aClass 
	| class |
	class := CMClass named: aClass name.
	class parent: package.
	class superName: aClass superclass name.
	class format: aClass typeOfClass.
	^ class! !

!CMPackageImporter class methodsFor: 'importing' stamp: 'cwp 5/20/2004 22:39'!
importFromPackageInfo: aPackageInfo
	| importer |
	importer _ self new.
	^ importer importPackage: aPackageInfo.
	! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 5/31/2004 12:20'!
annotateMethod: method withDate: dateString andTime: timeString

	| date time timestamp |
	date _ dateString findTokens: $/.
	time _ timeString findTokens: $:.
	timestamp _ DateAndTime
					year: date third asNumber
					month: date first asNumber
					day: date second asNumber
					hour: time first asNumber
					minute: time second asNumber
					second: 0.
	
	method addAnnotation: (CMAnnotation 
								selector: #timestamp: 
								argument: (CMLiteral for: timestamp asString)).
					! !

!CMPackageImporter methodsFor: 'accessing' stamp: 'cwp 5/20/2004 17:00'!
package
	^package! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 8/13/2004 22:02'!
annotateExtSegmentFromClass: aClass 
	| comment |

	segment category: aClass category.
	comment _ aClass organization classComment asString.
	comment isEmpty ifFalse: [segment comment: comment]! !

!CMPackageImporter class methodsFor: 'importing' stamp: 'cwp 6/15/2004 11:35'!
importAllPackages
	| bundle |
	bundle _ CMBundle new.
	PackageOrganizer default packages 
		do: [:ea | bundle addPackage: (CMPackageImporter importFromPackageInfo: ea)].

	^ bundle! !

!CMPackageImporter methodsFor: 'annotating' stamp: 'cwp 8/10/2004 11:33'!
annotateSegmentWithComment: aText 
	aText asString isEmpty 
		ifFalse: 
			[segment addAnnotation: (CMAnnotation selector: #comment:
						argument: (CMLiteral for: aText asString))]! !

!CMPackageImporter methodsFor: 'importing' stamp: 'cwp 8/11/2004 11:04'!
importExtension: aClassOrMetaClass 
	| theClass |
	theClass := aClassOrMetaClass theNonMetaClass.
	segment := CMSegment named: theClass name isMeta: aClassOrMetaClass isMeta.
	self annotateExtSegmentFromClass: theClass.
	(info extensionMethodsForClass: aClassOrMetaClass) 
		do: [:each | self importMethod: each].
	package addSegment: segment! !

Object subclass: #CMNode
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:02'!
isMethod
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:01'!
isClass
	^ false! !

CMNode subclass: #CMToken
	instanceVariableNames: 'whitespace value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMToken methodsFor: 'testing' stamp: 'cwp 5/25/2004 01:57'!
isToken
	^ true! !

!CMToken methodsFor: 'accessing' stamp: 'cwp 5/24/2004 20:49'!
value
	^ value! !

!CMToken class methodsFor: 'instance creation' stamp: 'cwp 5/30/2004 00:30'!
whitespace: aString value: anObject 
	^ self new whitespace: aString value: anObject! !

!CMToken methodsFor: 'accessing' stamp: 'cwp 5/24/2004 20:49'!
whitespace
	^ whitespace! !

!CMToken class methodsFor: 'instance creation' stamp: 'cwp 6/4/2004 15:43'!
bareValue: aString
	^ self whitespace: '' value: aString! !

!CMToken methodsFor: 'accessing' stamp: 'cwp 5/29/2004 11:39'!
whitespace: aString
	whitespace _ aString! !

!CMToken methodsFor: 'comparing' stamp: 'cwp 6/19/2004 13:11'!
= other
	^ other isToken and: [other value = value] and: [other whitespace = whitespace]! !

!CMToken class methodsFor: 'instance creation' stamp: 'cwp 6/4/2004 17:15'!
indentedValue: aString
	| indent |
	indent _ String new: 2.
	indent 
		at: 1 put: Character cr;
		at: 2 put: Character tab.
	^ self whitespace: indent value: aString! !

!CMToken methodsFor: 'copying' stamp: 'cwp 6/8/2004 23:02'!
deepCopy
	^ self class whitespace: whitespace copy value: value copy! !

!CMToken methodsFor: 'printing' stamp: 'cwp 6/1/2004 18:53'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $<.
	self value printOn: aStream.
	aStream nextPut: $>.! !

!CMToken class methodsFor: 'instance creation' stamp: 'cwp 5/31/2004 11:50'!
value: aString
	^ self whitespace: ' ' value: aString! !

CMToken subclass: #CMParseToken
	instanceVariableNames: 'start id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Parser'!

!CMParseToken methodsFor: 'converting' stamp: 'cwp 5/30/2004 00:31'!
withValue: aString
	^ self class id: id whitespace: whitespace start: start value: aString! !

!CMParseToken methodsFor: 'converting' stamp: 'cwp 5/29/2004 23:40'!
secondChar
	^ self class id: id whitespace: '' start: start + 1 value: (value second asString)! !

!CMParseToken class methodsFor: 'as yet unclassified' stamp: 'cwp 5/30/2004 00:33'!
id: id whitespace: whitespace start: start value: value
	^ self new id: id whitespace: whitespace start: start value: value! !

!CMParseToken methodsFor: 'converting' stamp: 'cwp 5/30/2004 00:36'!
asTreeToken
	^ CMToken whitespace: whitespace value: value! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/28/2004 15:12'!
start: anInteger
	start _ anInteger! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/30/2004 00:25'!
id
	^ id! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/29/2004 11:36'!
startPosition
	^ self start! !

!CMParseToken methodsFor: 'converting' stamp: 'cwp 5/29/2004 23:40'!
firstChar
	^ self withValue: value first asString! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/29/2004 11:37'!
start
	^ start! !

!CMParseToken methodsFor: 'initializing' stamp: 'cwp 5/30/2004 00:28'!
id: anInteger whitespace: aString start: anInteger3 value: anObject 
	id _ anInteger.
	whitespace _ aString.
	start _ anInteger3.
	value _ anObject.
! !

!CMParseToken methodsFor: 'accessing' stamp: 'cwp 5/30/2004 00:19'!
stopPosition
	^ start + value size! !

!CMToken methodsFor: 'visiting' stamp: 'cwp 5/31/2004 12:02'!
acceptGuide: aGuide
	aGuide visitToken: self! !

!CMToken methodsFor: 'initializing' stamp: 'cwp 5/30/2004 00:32'!
whitespace: aString1 value: aString2
	whitespace _ aString1.
	value _ aString2.! !

CMNode subclass: #CMArgument
	instanceVariableNames: 'colon identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
identifier
	^identifier! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:20'!
name
	^ self identifier value! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:27'!
identifier: anObject
	(identifier := anObject) parent: self! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 6/8/2004 16:58'!
hasColon
	^ colon notNil! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:18'!
colon
	^colon! !

!CMArgument methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:22'!
acceptGuide: aGuide
	aGuide visitArgument: self! !

!CMArgument class methodsFor: 'as yet unclassified' stamp: 'cwp 5/25/2004 14:22'!
identifier: aToken
	^ self colon: nil identifier: aToken! !

!CMArgument class methodsFor: 'as yet unclassified' stamp: 'cwp 7/8/2004 11:31'!
colon: colonToken identifier: idToken
	| argument |
	argument _ self new.
	colonToken ifNotNil: [argument colon: colonToken].
	argument identifier: idToken.
	^ argument! !

!CMArgument methodsFor: 'copying' stamp: 'cwp 6/8/2004 16:57'!
deepCopy
	| other |
	other _ super deepCopy.
	other identifier: identifier deepCopy.
	self hasColon ifTrue: [other colon: self colon deepCopy].
	^ other 
! !

!CMArgument class methodsFor: 'as yet unclassified' stamp: 'cwp 6/4/2004 17:07'!
named: aString
	^ self identifier: (CMToken value: aString)! !

!CMArgument methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:27'!
colon: anObject
	(colon := anObject) parent: self.! !

!CMArgument methodsFor: 'testing' stamp: 'cwp 5/25/2004 14:40'!
isArgument
	^ true! !

!CMNode methodsFor: 'visiting' stamp: 'cwp 6/4/2004 13:01'!
acceptGuide: aGuide
	aGuide visitNode: self! !

CMNode subclass: #CMValue
	instanceVariableNames: 'leftParen rightParen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMValue methodsFor: 'copying' stamp: 'cwp 6/8/2004 20:57'!
deepCopy
	| other |
	other _ super deepCopy.
	self hasParens ifTrue: [other 
							leftParen: leftParen deepCopy 
							rightParen: rightParen deepCopy].
	
	^ other! !

!CMValue methodsFor: 'accessing' stamp: 'cwp 5/25/2004 15:36'!
leftParen
	^leftParen! !

!CMValue methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:22'!
isValue
	^ true! !

CMValue subclass: #CMBlock
	instanceVariableNames: 'arguments body leftBracket bar rightBracket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 14:49'!
bar
	^bar! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:34'!
leftBracket: left rightBracket: right
	(leftBracket _ left) parent: self.
	(rightBracket _ right) parent: self! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
arguments
	^arguments! !

!CMBlock class methodsFor: 'instance creation' stamp: 'cwp 5/24/2004 17:19'!
arguments: anArray body: aSequence 
	^ self new arguments: anArray; body: aSequence! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:34'!
arguments: anObject
	arguments := anObject.
	arguments do: [:ea | ea parent: self]! !

!CMBlock methodsFor: 'testing' stamp: 'cwp 5/24/2004 17:21'!
isBlock	
	^ true! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:34'!
bar: anObject
	(bar := anObject) parent: self! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:50'!
leftBracket
	^ leftBracket! !

!CMBlock methodsFor: 'testing' stamp: 'cwp 6/8/2004 17:16'!
hasBar
	^ bar notNil! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 6/19/2004 14:47'!
body: anObject
	(body := anObject) parent: self.! !

!CMBlock methodsFor: 'copying' stamp: 'cwp 6/8/2004 17:15'!
deepCopy
	| other |
	other _ super deepCopy.
	self arguments do: [:ea | other addArgument: ea deepCopy].
	other body: self body deepCopy.
	other leftBracket: leftBracket deepCopy rightBracket: rightBracket deepCopy.
	self hasBar ifTrue: [other bar: self bar deepCopy].
	^ other
							! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/24/2004 16:56'!
body
	^body! !

!CMBlock methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:55'!
acceptGuide: aGuide
	aGuide visitBlock: self! !

!CMBlock class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 14:02'!
body: aSequence
	^ self arguments: #() body: aSequence! !

!CMBlock methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:50'!
rightBracket
	^ rightBracket! !

!CMValue methodsFor: 'testing' stamp: 'cwp 6/8/2004 20:53'!
hasParens
	^ leftParen notNil & rightParen notNil! !

CMValue subclass: #CMLiteral
	instanceVariableNames: 'token value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMLiteral class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2004 13:42'!
token: aToken value: anObject
	^ self new token: aToken; value: anObject! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:41'!
value: anObject
	value := anObject! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:33'!
name
	^ self token value! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:42'!
value
	^value! !

!CMLiteral methodsFor: 'copying' stamp: 'cwp 6/8/2004 17:24'!
deepCopy
	^ super deepCopy
		token: self token deepCopy;
		value: self value deepCopy;
		yourself! !

!CMLiteral class methodsFor: 'as yet unclassified' stamp: 'cwp 5/31/2004 12:24'!
for: anObject
	^ self token: (CMToken value: anObject printString) value: anObject! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 6/19/2004 14:31'!
token: anObject
	(token := anObject) parent: self.! !

!CMLiteral methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:41'!
token
	^token! !

!CMLiteral methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:57'!
acceptGuide: aGuide
	aGuide visitLiteral: self! !

!CMLiteral methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:43'!
isLiteral
	^ true! !

CMValue subclass: #CMAssignment
	instanceVariableNames: 'variable operator value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
variable
	^variable! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 7/8/2004 10:30'!
value: anObject
	value := anObject.
	value parent: self! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:21'!
value
	^value! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 7/8/2004 10:31'!
variable: anObject
	variable := anObject.
	variable parent: self! !

!CMAssignment class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 19:33'!
variable: aVariableReference operator: aToken value: aValue
	^ self new 
		variable: aVariableReference; 
		operator: aToken;
		value: aValue! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 7/8/2004 10:30'!
operator: anObject
	operator := anObject.
	operator parent: self! !

!CMAssignment methodsFor: 'copying' stamp: 'cwp 6/8/2004 17:05'!
deepCopy
	^ (super deepCopy)
		variable: self variable deepCopy;
		operator: self operator deepCopy;
		value: self value deepCopy;
		yourself! !

!CMAssignment methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:25'!
isAssignment
	^ true! !

!CMAssignment methodsFor: 'accessing' stamp: 'cwp 5/25/2004 19:31'!
operator
	^operator! !

!CMAssignment methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:54'!
acceptGuide: aGuide
	aGuide visitAssignment: self! !

CMValue subclass: #CMMessagePattern
	instanceVariableNames: 'selectorParts arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 6/19/2004 14:08'!
arguments: anObject
	arguments := anObject.
	arguments do: [:ea | ea parent: self]! !

!CMMessagePattern methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:56'!
isUnary
	^ self selector isUnary! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 6/1/2004 18:06'!
argument
	^ self arguments first! !

!CMMessagePattern class methodsFor: 'instance creation' stamp: 'cwp 5/31/2004 12:32'!
selector: aSelector arguments: aSequenceableCollection
	| keywords parts |
	keywords _ aSelector keywords.
	parts _ Array new: keywords size.
	parts at: 1 put: (CMToken whitespace: '' value: keywords first).
	2 to: keywords size do: [:i | parts at: i put: (CMToken value: (keywords at: i))].
	^ self 
		selectorParts: parts
		arguments: aSequenceableCollection! !

CMMessagePattern subclass: #CMMessage
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMessage class methodsFor: 'instance creation' stamp: 'cwp 6/4/2004 17:01'!
receiver: receiver selector: selector arguments: arguments
	| parts |
	parts _ selector keywords collect: [:ea | CMToken value: ea].
	^ self receiver: receiver selectorParts: parts arguments: arguments! !

!CMMessage methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:35'!
receiver
	^receiver! !

!CMMessage methodsFor: 'testing' stamp: 'cwp 7/5/2004 16:28'!
isCascaded
	^ self parent notNil 
		and: [self parent isCascade] 
		and: [self parent messages first ~~ self]! !

!CMMessage methodsFor: 'copying' stamp: 'cwp 6/8/2004 17:27'!
deepCopy
	^ super deepCopy receiver: self receiver deepCopy! !

!CMMessage methodsFor: 'accessing' stamp: 'cwp 6/19/2004 15:23'!
receiver: anObject
	receiver := anObject.
	anObject parent ifNil: [anObject parent: self]! !

!CMMessage methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:57'!
acceptGuide: aGuide
	aGuide visitMessage: self! !

!CMMessage class methodsFor: 'instance creation' stamp: 'cwp 5/24/2004 18:39'!
receiver: receiver selectorParts: parts arguments: args
	^ self new
			receiver: receiver;
			selectorParts: parts;
			arguments: args! !

!CMMessage methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:47'!
isMessage
	^ true! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:53'!
arguments
	^arguments! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 6/19/2004 14:08'!
selectorParts: anObject
	selectorParts := anObject.
	selectorParts do: [:ea | ea parent: self]! !

!CMMessagePattern methodsFor: 'copying' stamp: 'cwp 6/8/2004 17:33'!
deepCopy
	^ super deepCopy
		selectorParts: (self selectorParts collect: [:ea | ea deepCopy]);
		arguments: (self arguments collect: [:ea | ea deepCopy]);
		yourself! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:52'!
selectorParts
	^selectorParts! !

!CMMessagePattern class methodsFor: 'instance creation' stamp: 'cwp 5/26/2004 11:00'!
selectorParts: parts arguments: args
	^ self new
			selectorParts: parts;
			arguments: args! !

CMMessagePattern subclass: #CMAnnotation
	instanceVariableNames: ''
	classVariableNames: 'InvisibleSelectors'
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMAnnotation class methodsFor: 'initialize-release' stamp: 'cwp 6/3/2004 16:55'!
initialize
	InvisibleSelectors _ #(category: author: timestamp:)! !

!CMAnnotation methodsFor: 'printing' stamp: 'cwp 5/31/2004 10:32'!
name
	^ self selector! !

!CMAnnotation class methodsFor: 'instance creation' stamp: 'cwp 5/31/2004 12:07'!
selector: selector arguments: args
	^ (super selector: selector arguments: args)
		leftParen: (CMToken whitespace: '
	' value: '<')
		rightParen: (CMToken whitespace: '' value: '>')! !

!CMAnnotation methodsFor: 'testing' stamp: 'cwp 5/26/2004 10:54'!
isAnnotation
	^ true! !

!CMAnnotation methodsFor: 'notification' stamp: 'cwp 8/20/2004 18:02'!
itemKind
	^ #annotation! !

!CMAnnotation methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:03'!
acceptGuide: aGuide
	aGuide visitAnnotation: self! !

!CMAnnotation methodsFor: 'testing' stamp: 'cwp 6/3/2004 16:58'!
isInvisible
	^ InvisibleSelectors includes: self selector! !

!CMMessagePattern methodsFor: 'accessing' stamp: 'cwp 5/26/2004 15:06'!
selector
	^ (String streamContents: [:stream | selectorParts do: [:ea | stream nextPutAll: ea value]])
		asSymbol! !

!CMMessagePattern methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:56'!
isKeyword
	^ self selector isKeyword! !

!CMMessagePattern methodsFor: 'testing' stamp: 'cwp 5/26/2004 15:06'!
isBinary
	^ self selector isInfix! !

!CMMessagePattern class methodsFor: 'instance creation' stamp: 'cwp 5/31/2004 11:39'!
selector: aSelector argument: anObject
	^ self selector: aSelector arguments: (Array with: anObject)! !

!CMValue methodsFor: 'accessing' stamp: 'cwp 5/25/2004 15:37'!
rightParen
	^ rightParen! !

CMValue subclass: #CMCascade
	instanceVariableNames: 'messages semicolons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMCascade methodsFor: 'accessing' stamp: 'cwp 6/19/2004 14:51'!
firstMessage: aMessage
	messages _ OrderedCollection with: aMessage.
	semicolons _ OrderedCollection new.
	aMessage parent: self! !

!CMCascade methodsFor: 'copying' stamp: 'cwp 6/8/2004 17:20'!
deepCopy
	| other |
	other _ super deepCopy.
	other firstMessage: self messages first deepCopy.
	self messages allButFirst 
		with: self semicolons 
		do: [:msg :semi | other addMessage: msg semicolon: semi].
	^ other! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/25/2004 16:17'!
semicolons
	^semicolons! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 6/19/2004 14:49'!
addMessage: aMessage semicolon: aToken
	messages add: aMessage.
	semicolons add: aToken.
	aMessage parent: self.
	aToken parent: self.! !

!CMCascade methodsFor: 'testing' stamp: 'cwp 5/24/2004 18:59'!
isCascade
	^ true! !

!CMCascade methodsFor: 'accessing' stamp: 'cwp 5/24/2004 18:58'!
messages
	^ messages! !

!CMCascade class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 16:31'!
message: aMessage
	^ self new firstMessage: aMessage! !

!CMCascade methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:55'!
acceptGuide: aGuide
	aGuide visitCascade: self! !

!CMValue methodsFor: 'accessing' stamp: 'cwp 6/19/2004 14:23'!
leftParen: left rightParen: right
	(leftParen := left) parent: self.
	(rightParen := right) parent: self.! !

CMValue subclass: #CMVariableReference
	instanceVariableNames: 'identifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMVariableReference methodsFor: 'copying' stamp: 'cwp 6/8/2004 21:00'!
deepCopy
	^ super deepCopy identifier: self identifier! !

!CMVariableReference methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:04'!
isVariableReference
	^ true! !

!CMVariableReference class methodsFor: 'as yet unclassified' stamp: 'cwp 6/9/2004 17:35'!
identifier: aToken
	^ self new identifier: aToken! !

!CMVariableReference methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:01'!
acceptGuide: aGuide
	aGuide visitVariableReference: self! !

!CMVariableReference methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:03'!
identifier
	^ identifier! !

!CMVariableReference methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:02'!
identifier: aToken
	identifier := aToken.
	identifier parent: self.! !

!CMVariableReference methodsFor: 'accessing' stamp: 'cwp 5/24/2004 14:06'!
name
	^ self identifier value! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 7/8/2004 10:06'!
ancestorSatisfying: aSymbol 
	| cursor |
	cursor _ self.
	[cursor notNil and: [(cursor perform: aSymbol) not]]
		whileTrue: [cursor _ cursor parent].
	^ cursor! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 6/5/2004 21:14'!
root
	| root |
	root _ self.
	[root parent isNil] whileFalse: [root _ root parent].
	^ root! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:01'!
isBlock
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:01'!
isCascade
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:01'!
isAnnotation
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 7/20/2004 13:43'!
isClassSegment
	^false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:01'!
isArgument
	^ false! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 5/16/2004 22:22'!
parent: aNode
	parent _ aNode! !

CMNode subclass: #CMBundle
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMBundle methodsFor: 'accessing' stamp: 'cwp 8/12/2004 17:12'!
classNamed: aName
	^ self classNamed: aName ifNone: [self error: 'No class named ', aName]! !

!CMBundle methodsFor: 'accessing' stamp: 'cwp 6/16/2004 10:09'!
removePackage: aPackage
	packages ifNil: [^ nil].
	^ packages remove: aPackage ifAbsent: [^ nil]! !

!CMBundle methodsFor: 'visiting' stamp: 'cwp 6/7/2004 14:02'!
acceptGuide: aGuide
	aGuide visitBundle: self! !

!CMBundle methodsFor: 'accessing' stamp: 'cwp 8/12/2004 21:29'!
classNamed: aName ifNone: notFoundBlock
	self packages do: [:p | (p classNamed: aName) ifNotNilDo: [:c | ^ c]].
	^ notFoundBlock value! !

!CMBundle methodsFor: 'accessing' stamp: 'cwp 6/2/2004 12:46'!
packages
	^ packages ifNil: [#()]! !

!CMBundle methodsFor: 'accessing' stamp: 'cwp 6/16/2004 10:09'!
addPackage: aPackage
	packages ifNil: [packages _ SortedCollection new].
	packages add: aPackage! !

!CMBundle methodsFor: 'testing' stamp: 'cwp 6/18/2004 22:32'!
isBundle
	^ true! !

!CMBundle methodsFor: 'copying' stamp: 'cwp 6/8/2004 16:49'!
deepCopy
	| other |
	other _ super deepCopy.
	other parent: parent.
	packages do: [:ea | other addPackage: ea deepCopy].
	^ other! !

CMNode subclass: #CMSegment
	instanceVariableNames: 'name iVars methods annotations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMSegment methodsFor: 'convenience' stamp: 'cwp 7/18/2004 23:37'!
category
	^ self argumentForAnnotation: #category: ifNone: ''! !

!CMSegment methodsFor: 'accessing' stamp: 'cwp 8/12/2004 17:10'!
hostClass
	^ self bundle classNamed: self name! !

!CMSegment methodsFor: 'visiting' stamp: 'cwp 7/20/2004 13:48'!
acceptGuide: aGuide 
	aGuide visitMetaclassSegment: self! !

!CMSegment methodsFor: 'instance variables' stamp: 'cwp 7/18/2004 22:12'!
instanceVariables
	^ iVars ifNil: [#()]! !

!CMSegment methodsFor: 'methods' stamp: 'cwp 7/18/2004 23:35'!
removeMethodAt: aSelector
	methods ifNil: [^ nil].
	methods removeAllSuchThat: [:ea | ea selector = aSelector]! !

!CMSegment class methodsFor: 'instance creation' stamp: 'cwp 8/11/2004 10:54'!
named: aSymbol isMeta: aBoolean
	^ (aBoolean ifFalse: [CMClassSegment] ifTrue: [CMMetaclassSegment])
		named: aSymbol! !

!CMSegment methodsFor: 'instance variables' stamp: 'cwp 7/18/2004 22:12'!
addInstanceVariable: anInstanceVariable 
	iVars ifNil: [iVars _ OrderedCollection new].
	iVars add: anInstanceVariable.
	anInstanceVariable parent: self.! !

!CMSegment methodsFor: 'copying' stamp: 'cwp 7/19/2004 19:56'!
deepCopy
	| other |
	other _ self class basicNew.
	other name: self name.
	self instanceVariables do: [:ea | other addInstanceVariable: ea deepCopy].
	self methods do: [:ea | other addMethod: ea deepCopy].
	self annotations do: [:ea | other addAnnotation: ea deepCopy].
	^ other! !

!CMSegment methodsFor: 'convenience' stamp: 'cwp 8/19/2004 18:48'!
category: aSymbol
	self annotateWithSelector: #category: andArgument: aSymbol! !

!CMSegment methodsFor: 'instance variables' stamp: 'cwp 7/18/2004 22:12'!
removeInstanceVariable: anInstanceVariableNode
	iVars ifNil: [^ nil].
	^ (iVars remove: anInstanceVariableNode ifAbsent: [^ nil]) parent: nil.! !

!CMSegment methodsFor: 'annotations' stamp: 'cwp 7/18/2004 23:36'!
annotations
	^ annotations ifNil: [#()]! !

!CMSegment methodsFor: 'annotations' stamp: 'cwp 7/18/2004 23:36'!
argumentForAnnotation: selector ifNone: anObject
	^ (self annotations 
		detect: [:ann | ann selector = selector]
		ifNone: [^ anObject]) argument value! !

!CMSegment methodsFor: 'convenience' stamp: 'cwp 7/18/2004 23:37'!
comment
	^ self argumentForAnnotation: #comment: ifNone: ''! !

!CMSegment methodsFor: 'methods' stamp: 'cwp 7/18/2004 23:35'!
addMethod: aMethod 
	methods ifNil: [methods _ SortedCollection new].
	methods add: aMethod.
	aMethod parent: self.! !

!CMSegment methodsFor: 'annotations' stamp: 'cwp 8/20/2004 17:57'!
annotateWithSelector: aSelector andArgument: aLiteralValue
	| old |
	old _ self annotations detect: [:ea | ea selector = aSelector] ifNone: [nil].
	old ifNotNil: [self removeAnnotation: old].
	self addAnnotation: (CMAnnotation 
							selector: aSelector
							argument: (CMLiteral for: aLiteralValue)).
	^ old! !

!CMSegment methodsFor: 'methods' stamp: 'cwp 7/18/2004 23:35'!
removeMethod: aMethod
	methods ifNil: [^ nil].
	^ (methods remove: aMethod ifAbsent: [^ nil]) parent: nil.! !

CMSegment subclass: #CMClassSegment
	instanceVariableNames: 'cVars imports initializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMClassSegment methodsFor: 'copying' stamp: 'cwp 7/19/2004 19:52'!
deepCopy
	| other |
	other _ super deepCopy.
	self classVariables do: [:ea | other addClassVariable: ea deepCopy].
	self poolImports do: [:ea | other addPoolImport: ea deepCopy].
	self hasInitializer ifTrue: [other initializer: self initializer].
	^ other! !

!CMClassSegment methodsFor: 'class variables' stamp: 'cwp 7/18/2004 22:00'!
classVariables
	^ cVars ifNil: [#()]! !

!CMClassSegment methodsFor: 'pool imports' stamp: 'cwp 7/18/2004 22:07'!
addPoolImport: aPoolImportNode
	imports ifNil: [imports _ OrderedCollection new].
	imports add: aPoolImportNode.
	aPoolImportNode parent: self.! !

!CMClassSegment methodsFor: 'visiting' stamp: 'cwp 7/20/2004 13:47'!
acceptGuide: aGuide 
	aGuide visitClassSegment: self! !

!CMClassSegment methodsFor: 'comparing' stamp: 'cwp 8/10/2004 11:10'!
= other
	^ other isClassSegment and: [other name = self name]! !

!CMClassSegment methodsFor: 'initializer' stamp: 'cwp 7/18/2004 22:06'!
hasInitializer
	^ initializer notNil! !

!CMClassSegment methodsFor: 'pool imports' stamp: 'cwp 7/18/2004 22:07'!
removePoolImport: aPoolImportNode
	imports ifNil: [^ #()].
	^ (imports remove: aPoolImportNode ifAbsent: [^ nil]) parent: nil.! !

!CMClassSegment methodsFor: 'pool imports' stamp: 'cwp 7/18/2004 22:07'!
hasPoolImports
	^ imports notNil and: [imports isEmpty not]! !

!CMClassSegment methodsFor: 'testing' stamp: 'cwp 7/20/2004 13:43'!
isClassSegment
	^true! !

!CMClassSegment methodsFor: 'class variables' stamp: 'cwp 7/18/2004 22:01'!
removeClassVariable: aClassVariableNode
	cVars ifNil: [^ nil].
	^ (cVars remove: aClassVariableNode ifAbsent: [^ nil]) parent: nil.! !

!CMClassSegment methodsFor: 'pool imports' stamp: 'cwp 7/18/2004 22:07'!
poolImports
	^ imports ifNil: [^ #()]! !

!CMClassSegment methodsFor: 'class variables' stamp: 'cwp 7/18/2004 22:01'!
hasClassVariables
	^ cVars notNil and: [cVars isEmpty not]! !

!CMClassSegment methodsFor: 'initializer' stamp: 'cwp 7/18/2004 22:06'!
initializer
	^ initializer! !

!CMClassSegment methodsFor: 'initializer' stamp: 'cwp 7/18/2004 22:06'!
initializer: anExpression
	initializer _ anExpression! !

!CMClassSegment class methodsFor: 'instance creation' stamp: 'cwp 8/10/2004 11:18'!
named: className instVarNames: iVarNames classVarNames: cVarNames poolImports: poolNames
	| segment |
	segment _ self named: className.
	iVarNames substrings do: [:ea | segment addInstanceVariable: (CMInstanceVariable named: ea)].
	cVarNames substrings do: [:ea | segment addInstanceVariable: (CMInstanceVariable named: ea)].
	poolNames substrings do: [:ea | segment addInstanceVariable: (CMInstanceVariable named: ea)].
	^ segment
! !

!CMClassSegment methodsFor: 'notification' stamp: 'cwp 8/19/2004 17:57'!
itemKind
	^ #segment! !

!CMClassSegment methodsFor: 'class variables' stamp: 'cwp 7/18/2004 22:00'!
addClassVariable: aClassVariableNode
	cVars ifNil: [cVars _ OrderedCollection new].
	cVars add: aClassVariableNode.
	aClassVariableNode parent: self.! !

!CMSegment methodsFor: 'convenience' stamp: 'cwp 8/11/2004 12:07'!
comment: aString
	self annotateWithSelector: #comment: andArgument: aString! !

!CMSegment methodsFor: 'instance variables' stamp: 'cwp 7/18/2004 22:12'!
hasInstanceVariables
	^ iVars notNil and: [iVars isEmpty not]! !

!CMSegment methodsFor: 'name' stamp: 'cwp 7/19/2004 13:04'!
name: aSymbol	
	name _ aSymbol! !

!CMSegment methodsFor: 'notification' stamp: 'cwp 8/20/2004 18:03'!
comment: aString requestor: anObject
	self annotateSelector: #comment: argument: aString requestor: anObject! !

!CMSegment methodsFor: 'annotations' stamp: 'cwp 7/18/2004 23:36'!
removeAnnotation: anAnnotation
	annotations ifNil: [^ nil].
	^ (annotations remove: anAnnotation ifAbsent: [^ nil]) parent: nil.! !

!CMSegment class methodsFor: 'instance creation' stamp: 'cwp 7/19/2004 13:03'!
named: aSymbol 
	^ self new name: aSymbol! !

CMSegment subclass: #CMMetaclassSegment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMetaclassSegment methodsFor: 'comparing' stamp: 'cwp 8/10/2004 11:11'!
= other
	^ other isMetaclassSegment and: [other name = self name]! !

!CMMetaclassSegment methodsFor: 'testing' stamp: 'cwp 8/6/2004 23:46'!
isMetaclassSegment
	^true! !

!CMSegment methodsFor: 'testing' stamp: 'cwp 8/9/2004 21:02'!
isSegment
	^ true! !

!CMSegment methodsFor: 'methods' stamp: 'cwp 7/18/2004 23:35'!
addOrReplaceMethod: aCMMethod 
	self removeMethod: aCMMethod.
	self addMethod: aCMMethod! !

!CMSegment methodsFor: 'notification' stamp: 'cwp 8/20/2004 18:00'!
category: aSymbol requestor: anObject
	self annotateSelector: #category: argument: aSymbol requestor: anObject! !

!CMSegment methodsFor: 'name' stamp: 'cwp 7/19/2004 13:04'!
name 
	^ name! !

!CMSegment methodsFor: 'testing' stamp: 'cwp 8/11/2004 11:14'!
isExtension
	self parent classes detect: [:ea | ea name = self name] ifNone: [^ true].
	^ false! !

!CMSegment methodsFor: 'notification' stamp: 'cwp 8/20/2004 18:05'!
annotateSelector: aSelector argument: aLiteralValue requestor: anObject
	| old new |
	old _ self annotations detect: [:ea | ea selector = aSelector] ifNone: [nil].
	new _ (CMAnnotation 
				selector: aSelector
				argument: (CMLiteral for: aLiteralValue)).
	old ifNotNil: [self removeAnnotation: old].
	self addAnnotation: new.
	old 
		ifNil: [self notifier requestor: anObject added: new] 
		ifNotNil: [self notifier requestor: anObject replaced: old with: new]! !

!CMSegment methodsFor: 'methods' stamp: 'cwp 7/18/2004 23:35'!
categories
	| categories |
	categories _ Set new.
	self methods do: [:m | (m annotations 
								detect: [:ann | ann selector = #category:]
								ifNone: [nil])
								ifNotNilDo: [:cat | categories add: cat argument value]].
	^ categories asArray sort! !

!CMSegment methodsFor: 'methods' stamp: 'cwp 7/18/2004 23:35'!
methods
	^ methods ifNil: [#()]! !

!CMSegment methodsFor: 'annotations' stamp: 'cwp 7/18/2004 23:36'!
addAnnotation: anAnnotation
	annotations ifNil: [annotations _ OrderedCollection new].
	annotations add: anAnnotation.
	anAnnotation parent: self.
	^ anAnnotation! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:01'!
isArray
	^ false! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 7/19/2004 19:56'!
method
	^ self ancestorSatisfying: #isMethod! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 6/15/2004 23:18'!
library
	^ parent isLibrary ifTrue: [parent] ifFalse: [parent library]! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:02'!
isValue
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:02'!
isClassVariable
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/18/2004 22:28'!
isPackage
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:02'!
isMessage
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:02'!
isInstanceVariable
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 8/10/2004 09:56'!
isExtension
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/18/2004 22:32'!
isBundle
	^ false! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 6/16/2004 10:15'!
parent
	^ (parent isNil or: [parent isLibrary])
		ifFalse: [parent]! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:02'!
isReturn
	^ false! !

CMNode subclass: #CMMethod
	instanceVariableNames: 'selectorParts arguments annotations body'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:59'!
isBinary
	^ self selector isInfix! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:08'!
body
	^body! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:07'!
arguments
	^arguments! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/24/2004 13:07'!
selectorParts
	^selectorParts! !

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/24/2004 13:20'!
isMethod
	^ true! !

!CMMethod methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:58'!
acceptGuide: aGuide
	aGuide visitMethod: self! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/26/2004 14:58'!
selector
	^ (String streamContents: [:stream | selectorParts do: [:ea | stream nextPutAll: ea value]])
		asSymbol! !

!CMMethod class methodsFor: 'instance creation' stamp: 'cwp 7/7/2004 21:26'!
selectorParts: parts arguments: args annotations: annotations body: sequence
	| method |
	method _ self new.
	method
		selectorParts: parts arguments: args;
		annotations: annotations.
	sequence ifNotNil: [method body: sequence].
	^ method! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:58'!
annotations
	^annotations! !

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:57'!
isUnary
	^ self selector isUnary! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 7/7/2004 17:06'!
body: anObject
	body := anObject.
	body parent: self! !

!CMMethod methodsFor: 'comparing' stamp: 'cwp 5/31/2004 21:43'!
<= other
	^ self selector <= other selector! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 6/8/2004 23:34'!
addAnnotation: anAnnotation
	annotations ifNil: [annotations _ OrderedCollection new].
	annotations add: anAnnotation.
	anAnnotation parent: self.
	^ anAnnotation! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/25/2004 23:07'!
name
	^ self selector! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:01'!
selectorParts: aCollection arguments: aCollection2
	selectorParts := aCollection.
	selectorParts do: [:ea | ea parent: self].
	
	arguments := aCollection2.
	arguments do: [:ea | ea parent: self].! !

!CMMethod methodsFor: 'accessing' stamp: 'cwp 5/26/2004 10:58'!
annotations: anObject
	annotations := anObject! !

!CMMethod methodsFor: 'converting' stamp: 'cwp 7/20/2004 13:44'!
asMethodReference
	| ref |
	ref := MethodReference new.
	ref 
		setClassSymbol: self parent name
		classIsMeta: parent isMetaclassSegment
		methodSymbol: self selector
		stringVersion: ''.
	^ref! !

!CMMethod class methodsFor: 'instance creation' stamp: 'cwp 6/4/2004 21:02'!
selector: aUnarySelector
	| token |
	token _ CMToken bareValue: aUnarySelector asString.
	^ self selectorParts: {token} arguments: #() body: nil! !

!CMMethod methodsFor: 'copying' stamp: 'cwp 6/8/2004 23:33'!
deepCopy
	| other |
	other _ super deepCopy.
	other 
		selectorParts: (self selectorParts collect: [:ea | ea deepCopy])
		arguments: (self arguments collect: [:ea | ea deepCopy]);
		body: (self body deepCopy).
	self annotations do: [:ea | other addAnnotation: ea deepCopy].
	^ other! !

!CMMethod methodsFor: 'testing' stamp: 'cwp 5/26/2004 14:58'!
isKeyword
	^ self selector isKeyword! !

!CMMethod methodsFor: 'convenience' stamp: 'cwp 6/3/2004 06:04'!
category
	^ (self annotations 
			detect: [:ea | ea selector = #category:]
			ifNone: [^ 'as yet unclassified'])
				argument value! !

!CMMethod methodsFor: 'convenience' stamp: 'cwp 6/19/2004 13:51'!
category: aSymbol 
	| ann |
	ann _ CMAnnotation selector: #category: argument: (CMLiteral for: aSymbol).
	self annotations removeAllSuchThat: [:ea | ea selector = #category:].
	self addAnnotation: ann! !

!CMMethod class methodsFor: 'instance creation' stamp: 'cwp 5/26/2004 11:09'!
selectorParts: parts arguments: args body: sequence
	^ self selectorParts: parts arguments: args annotations: OrderedCollection new body: sequence! !

CMNode subclass: #CMReturn
	instanceVariableNames: 'return value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMReturn methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:59'!
acceptGuide: aGuide
	aGuide visitReturn: self! !

!CMReturn class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 02:05'!
return: aToken value: aValueNode
	^ self new return: aToken value: aValueNode! !

!CMReturn methodsFor: 'copying' stamp: 'cwp 6/8/2004 22:09'!
deepCopy
	^ super deepCopy
		return: self return deepCopy value: self value deepCopy;
		yourself
! !

!CMReturn methodsFor: 'accessing' stamp: 'cwp 5/24/2004 15:39'!
value
	^ value! !

!CMReturn methodsFor: 'accessing' stamp: 'cwp 5/25/2004 02:08'!
return
	^ return! !

!CMReturn methodsFor: 'testing' stamp: 'cwp 5/24/2004 15:48'!
isReturn
	^ true! !

!CMReturn methodsFor: 'accessing' stamp: 'cwp 6/19/2004 14:57'!
return: aToken value: aValueNode
	(return := aToken) parent: self.
	(value := aValueNode) parent: self! !

!CMNode methodsFor: 'copying' stamp: 'cwp 6/9/2004 13:09'!
deepCopy
	^ self class new parent: parent! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:02'!
isToken
	^ false! !

CMNode subclass: #CMPackage
	instanceVariableNames: 'name classes segments globals pools initializer initializationSequence dependencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMPackage methodsFor: 'accessing' stamp: 'cwp 5/14/2004 01:02'!
name: aString 
	name _ aString! !

!CMPackage methodsFor: 'comparing' stamp: 'cwp 6/16/2004 09:54'!
<= other
	^ self name <= other name! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:55'!
initializer
	^ initializer! !

!CMPackage methodsFor: 'notification' stamp: 'cwp 8/20/2004 23:59'!
defineClass: aClass requestor: anObject
	| old |
	old _ self classes detect: [:ea | ea name = aClass name] ifNone: [].
	old ifNotNil: [self removeClass: old].
	self addClass: aClass.
	old 
		ifNil: [self notifier requestor: anObject added: aClass]
		ifNotNil: [self notifier requestor: anObject replaced: old with: aClass]! !

!CMPackage methodsFor: 'segments' stamp: 'cwp 7/20/2004 13:44'!
metaclassSegmentFor: class 
	^self segments 
		detect: [:ea | ea isMetaclassSegment and: [ea name = class name]]
		ifNone: []! !

!CMPackage class methodsFor: 'instance creation' stamp: 'cwp 5/20/2004 17:07'!
named: aSymbol
	^ self new name: aSymbol! !

!CMPackage methodsFor: 'segments' stamp: 'cwp 7/20/2004 13:41'!
removeSegment: aSegmentNode 
	segments ifNil: [^nil].
	^segments remove: aSegmentNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'pools' stamp: 'cwp 5/20/2004 16:53'!
addPool: aPoolNode
	pools ifNil: [pools _ OrderedCollection new].
	pools add: aPoolNode! !

!CMPackage methodsFor: 'globals' stamp: 'cwp 5/20/2004 16:51'!
addGlobal: aGlobalNode
	globals ifNil: [globals _ OrderedCollection new].
	globals add: aGlobalNode! !

!CMPackage methodsFor: 'globals' stamp: 'cwp 5/20/2004 16:51'!
globals
	^ globals ifNil: [#()]! !

!CMPackage methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:59'!
acceptGuide: aGuide
	aGuide visitPackage: self! !

!CMPackage methodsFor: 'testing' stamp: 'cwp 6/18/2004 22:38'!
isPackage
	^ true! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:56'!
hasInitializer
	^ initializer notNil! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 6/2/2004 22:03'!
addClass: aClassNode
	classes ifNil: [classes _ SortedCollection new].
	classes add: aClassNode.
	aClassNode parent: self! !

!CMPackage methodsFor: 'accessing' stamp: 'cwp 5/16/2004 20:29'!
name
	^ name! !

!CMPackage methodsFor: 'pools' stamp: 'cwp 5/20/2004 16:53'!
pools
	^ pools ifNil: [#()]! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:57'!
initializationSequence: anInitializationSequenceNode
	initializationSequence _ anInitializationSequenceNode! !

!CMPackage methodsFor: 'dependencies' stamp: 'cwp 7/7/2004 18:57'!
dependencies
	^ dependencies ifNil: [#()]! !

!CMPackage methodsFor: 'segments' stamp: 'cwp 7/20/2004 13:40'!
segments
	^segments ifNil: [#()]! !

!CMPackage methodsFor: 'segments' stamp: 'cwp 7/20/2004 13:43'!
classSegmentFor: class 
	^self segments 
		detect: [:ea | ea isClassSegment and: [ea name = class name]]
		ifNone: []! !

!CMPackage methodsFor: 'convenience' stamp: 'cwp 8/10/2004 10:27'!
metaclassSegments
	^ self segments select: [:ea | ea isMetaclassSegment]! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:57'!
initializationSequence
	^ initializationSequence! !

!CMPackage methodsFor: 'notification' stamp: 'cwp 9/19/2004 18:26'!
removeClass: aClassNode requestor: anObject 
	self removeClass: aClassNode.
	self notifier requestor: anObject pruned: aClassNode
	! !

!CMPackage methodsFor: 'copying' stamp: 'cwp 8/11/2004 11:30'!
deepCopy
	| other |
	other := super deepCopy.
	other name: name copy.
	self classes do: [:ea | other addClass: ea deepCopy].
	self segments do: [:ea | other addSegment: ea deepCopy].
	self globals do: [:ea | other addGlobal: ea deepCopy].
	self pools do: [:ea | other addPool: ea deepCopy].
	self dependencies do: [:ea | other addDependency: ea deepCopy].
	other
		initializer: initializer deepCopy;
		initializationSequence: initializationSequence deepCopy.
	^other! !

!CMPackage methodsFor: 'pools' stamp: 'cwp 5/20/2004 16:54'!
removePool: aPoolNode
	pools ifNil: [^ nil].
	^ pools remove: aPoolNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'globals' stamp: 'cwp 5/20/2004 16:52'!
removeGlobal: aGlobalNode
	globals ifNil: [^ nil].
	^ globals remove: aGlobalNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/20/2004 16:50'!
removeClass: aClassNode
	classes ifNil: [^ nil].
	^ classes remove: aClassNode ifAbsent: [nil]! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 8/12/2004 21:30'!
classNamed: aName
	self classes do: [:c | c name = aName ifTrue: [^ c]].
	^ nil! !

!CMPackage methodsFor: 'convenience' stamp: 'cwp 8/10/2004 10:27'!
classSegments
	^ self segments select: [:ea | ea isClassSegment]! !

!CMPackage methodsFor: 'notification' stamp: 'cwp 8/20/2004 17:53'!
defineSegment: aSegment requestor: anObject
	| old |
	old _ self segments detect: [:ea | ea = aSegment] ifNone: [].
	old ifNotNil: [self removeSegment: old].
	self addSegment: aSegment.
	self notifier requestor: anObject added: aSegment ! !

!CMPackage methodsFor: 'dependencies' stamp: 'cwp 7/7/2004 18:58'!
addDependency: aPackage
	dependencies ifNil: [dependencies _ Set new].
	^ dependencies add: aPackage! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:57'!
hasInitializationSequence
	^ initializationSequence notNil! !

!CMPackage methodsFor: 'classes' stamp: 'cwp 5/20/2004 16:46'!
classes
	^ classes ifNil: [#()]! !

!CMPackage methodsFor: 'convenience' stamp: 'cwp 8/10/2004 21:48'!
categories
	| categories |
	categories _ Set new.
	self segments do: [:seg | (seg annotations 
								detect: [:ann | ann selector = #category:]
								ifNone: [nil])
									ifNotNilDo: [:cat | categories add: cat argument value]].
	^ categories asArray sort! !

!CMPackage methodsFor: 'dependencies' stamp: 'cwp 7/7/2004 19:45'!
dependOn: aPackage
	self addDependency: aPackage! !

!CMPackage methodsFor: 'dependencies' stamp: 'cwp 7/7/2004 19:52'!
addDependeciesToBundle: aCMBundle 
	aCMBundle addPackage: self.
	self dependencies do: [:ea | aCMBundle addPackage: ea]! !

!CMPackage methodsFor: 'segments' stamp: 'cwp 7/20/2004 13:39'!
addSegment: aSegmentNode 
	segments ifNil: [segments := OrderedCollection new].
	segments add: aSegmentNode.
	aSegmentNode parent: self.
	^aSegmentNode! !

!CMPackage methodsFor: 'initializers' stamp: 'cwp 5/20/2004 16:55'!
initializer: anInitializerNode
	initializer _ anInitializerNode! !

!CMNode methodsFor: 'printing' stamp: 'cwp 6/4/2004 13:00'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $<.
	aStream nextPutAll: self name.
	aStream nextPut: $>! !

!CMNode methodsFor: 'printing' stamp: 'cwp 6/4/2004 13:00'!
name
	^ ''! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/18/2004 21:11'!
isNode
	^ true! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 7/7/2004 19:54'!
package
	^ self ancestorSatisfying: #isPackage! !

CMNode subclass: #CMClass
	instanceVariableNames: 'name superName format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMClass methodsFor: 'format' stamp: 'cwp 6/8/2004 16:54'!
hasFormat
	^ format notNil! !

!CMClass methodsFor: 'core extension' stamp: 'cwp 7/19/2004 17:22'!
methods
	^ self core methods! !

!CMClass methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:56'!
acceptGuide: aGuide
	aGuide visitClass: self! !

!CMClass methodsFor: 'core extension' stamp: 'cwp 7/19/2004 17:22'!
category
	^ self core category! !

!CMClass methodsFor: 'notification' stamp: 'cwp 8/19/2004 17:54'!
itemKind
	^ #class! !

!CMClass methodsFor: 'core extension' stamp: 'cwp 7/19/2004 17:27'!
poolImports
	^ self core poolImports! !

!CMClass methodsFor: 'core extension' stamp: 'cwp 7/19/2004 14:16'!
comment
	^ self core comment! !

!CMClass class methodsFor: 'as yet unclassified' stamp: 'cwp 7/19/2004 12:42'!
named: aStringOrSymbol 
	^ self new name: aStringOrSymbol asSymbol! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 17:11'!
name: aNameNode
	name _ aNameNode! !

!CMClass methodsFor: 'convenience' stamp: 'cwp 7/20/2004 13:39'!
core
	^(self parent classSegmentFor: self) 
		ifNil: [self parent addSegment: (CMClassSegment named: self name)]! !

!CMClass methodsFor: 'testing' stamp: 'cwp 5/15/2004 00:59'!
isClass
	^ true! !

!CMClass methodsFor: 'comparing' stamp: 'cwp 7/19/2004 12:25'!
<= other 
	^ self name <= other name! !

!CMClass methodsFor: 'core extension' stamp: 'cwp 7/19/2004 20:03'!
categories
	^ self core categories! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 18:43'!
superName: aNameNode
	superName _ aNameNode! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 18:44'!
hasSuperName
	^ superName notNil! !

!CMClass methodsFor: 'name' stamp: 'cwp 7/7/2004 20:56'!
fullName
	^ self name! !

!CMClass methodsFor: 'copying' stamp: 'cwp 7/19/2004 19:50'!
deepCopy
	| other |
	other _ self class basicNew.
	other name: self name.
	other superName: self superName.
	other format: self format.
	^ other! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/15/2004 00:49'!
name
	^ name! !

!CMClass methodsFor: 'convenience' stamp: 'cwp 8/6/2004 23:51'!
metacore
	^(self parent metaclassSegmentFor: self) 
		ifNil: [self parent addSegment: (CMMetaclassSegment named: self name)]! !

!CMClass methodsFor: 'format' stamp: 'cwp 5/20/2004 18:48'!
format
	^ format! !

!CMClass methodsFor: 'core extension' stamp: 'cwp 7/19/2004 20:03'!
classVariables
	^ self core classVariables! !

!CMClass methodsFor: 'format' stamp: 'cwp 5/20/2004 18:48'!
format: anInstanceStateNode 
	format := anInstanceStateNode! !

!CMClass methodsFor: 'name' stamp: 'cwp 5/20/2004 18:43'!
superName
	^ superName! !

!CMClass methodsFor: 'testing' stamp: 'cwp 5/20/2004 19:16'!
refersTo: anObject
	anObject isBehavior ifFalse: [^ false].
	name = anObject name ifFalse: [^ false].
	superName = anObject superclass name ifFalse: [^ false].
	format = anObject typeOfClass ifFalse: [^ false]. 
	^ true! !

!CMClass methodsFor: 'core extension' stamp: 'cwp 7/19/2004 20:00'!
annotations
	^ self core annotations! !

!CMClass class methodsFor: 'as yet unclassified' stamp: 'cwp 6/9/2004 23:39'!
superclass: superName subclass: subName instVarNames: ivars classVarNames: cvars poolImports: pools
	| class |
	class _ (self named: subName) superName: superName.
	ivars substrings do: [:ea | class addInstanceVariable: (CMInstanceVariable named: ea)].
	cvars substrings do: [:ea | class addInstanceVariable: (CMInstanceVariable named: ea)].
	pools substrings do: [:ea | class addInstanceVariable: (CMInstanceVariable named: ea)].
	^ class
	! !

!CMClass class methodsFor: 'as yet unclassified' stamp: 'cwp 8/12/2004 21:36'!
fromBaseClass: aClass
	^ (self name: aClass name superName: aClass superclass name)
		format: aClass typeOfClass! !

!CMClass methodsFor: 'core extension' stamp: 'cwp 7/19/2004 17:24'!
instanceVariables
	^ self core instanceVariables! !

!CMClass class methodsFor: 'as yet unclassified' stamp: 'cwp 8/15/2004 17:03'!
name: subName superName: superName 
	| class |
	class _ (self named: subName) 
				superName: superName;
				format: #normal.
	^ class
	! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/15/2004 23:12'!
isLibrary
	^ false! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 8/14/2004 22:39'!
notifier
	^ self library notifier! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:02'!
isVariableReference
	^ false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:01'!
isAssignment
	^ false! !

CMNode subclass: #CMStatementList
	instanceVariableNames: 'statements periods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMStatementList methodsFor: 'accessing' stamp: 'cwp 5/25/2004 11:25'!
periods
	^periods! !

!CMStatementList class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 11:29'!
statements: statements periods: periods
	^ self new statements: statements periods: periods! !

!CMStatementList methodsFor: 'copying' stamp: 'cwp 6/8/2004 22:10'!
deepCopy
	^ super deepCopy
		statements: (self statements collect: [:ea | ea deepCopy])
		periods: (self periods collect: [:ea | ea deepCopy]).! !

CMStatementList subclass: #CMArray
	instanceVariableNames: 'leftBrace rightBrace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMArray methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:54'!
acceptGuide: aGuide
	aGuide visitArray: self! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:36'!
leftBrace: left rightBrace: right
	(leftBrace := left) parent: self.
	(rightBrace := right) parent: self.! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:20'!
rightBrace
	^rightBrace! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 5/25/2004 13:20'!
leftBrace
	^leftBrace! !

!CMArray methodsFor: 'accessing' stamp: 'cwp 6/8/2004 17:00'!
hasBraces
	^ leftBrace notNil & rightBrace notNil! !

!CMArray methodsFor: 'copying' stamp: 'cwp 6/8/2004 17:01'!
deepCopy
	| other |
	other _ super deepCopy.
	self hasBraces ifTrue: [other leftBrace: leftBrace deepCopy rightBrace: rightBrace deepCopy].
	^ other! !

!CMArray class methodsFor: 'as yet unclassified' stamp: 'cwp 5/24/2004 19:07'!
statements: anArray
	^ self new statements: anArray! !

!CMArray methodsFor: 'testing' stamp: 'cwp 5/24/2004 19:08'!
isArray
	^ true! !

!CMStatementList methodsFor: 'accessing' stamp: 'cwp 5/25/2004 11:25'!
statements
	^statements! !

!CMStatementList methodsFor: 'accessing' stamp: 'cwp 6/19/2004 14:48'!
statements: aCollection1 periods: aCollection2 
	statements := aCollection1.
	periods := aCollection2.
	statements do: [:ea | ea parent: self].
	periods do: [:ea | ea parent: self]! !

CMStatementList subclass: #CMSequence
	instanceVariableNames: 'leftBar temporaries rightBar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMSequence methodsFor: 'testing' stamp: 'cwp 5/24/2004 14:32'!
isSequence
	^ true! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:24'!
leftBar: left rightBar: right
	(leftBar := left) parent: self.
	(rightBar := right) parent: self.! !

!CMSequence methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:00'!
acceptGuide: aGuide
	aGuide visitSequence: self! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/25/2004 01:41'!
rightBar
	^rightBar! !

!CMSequence class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 11:31'!
temporaries: temps statements: statements
	^ self new temporaries: temps statements: statements! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 6/8/2004 22:10'!
temporaries
	^ temporaries ifNil: [#()]! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 7/8/2004 11:20'!
temporaries: anObject
	temporaries := anObject.
	temporaries do: [:ea | ea parent: self]! !

!CMSequence methodsFor: 'copying' stamp: 'cwp 7/19/2004 19:59'!
deepCopy
	| other |
	other _ super deepCopy.
	self hasBars ifTrue: [other leftBar: self leftBar deepCopy rightBar: self rightBar deepCopy].
	other temporaries: (self temporaries collect: [:ea | ea deepCopy]).
	^ other! !

!CMSequence methodsFor: 'testing' stamp: 'cwp 6/8/2004 20:25'!
hasBars
	^ leftBar notNil & rightBar notNil! !

!CMSequence class methodsFor: 'instance creation' stamp: 'cwp 5/25/2004 11:53'!
temporaries: temps statements: statements periods: periods
	^ (self statements: statements periods: periods) temporaries: temps! !

!CMSequence class methodsFor: 'instance creation' stamp: 'cwp 5/24/2004 14:31'!
statements: statements
	^ self new statements: statements! !

!CMSequence methodsFor: 'accessing' stamp: 'cwp 5/25/2004 01:41'!
leftBar
	^leftBar! !

!CMNode methodsFor: 'accessing' stamp: 'cwp 7/7/2004 19:48'!
bundle
	| bundle |
	bundle _ CMBundle new.
	self package addDependeciesToBundle: bundle.
	^ bundle! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/19/2004 14:14'!
descendsFrom: aNode
	| ancestor |
	ancestor _ self.
	[ancestor notNil] whileTrue: [aNode == ancestor ifTrue: [^ true]. 
								ancestor _ ancestor parent].
	^ false! !

CMNode subclass: #CMVariable
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMVariable class methodsFor: 'instance creation' stamp: 'cwp 5/15/2004 22:48'!
named: aSymbol
	^ self new name: aSymbol! !

CMVariable subclass: #CMInstanceVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMInstanceVariable methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:56'!
acceptGuide: aGuide
	aGuide visitInstanceVariable: self! !

!CMInstanceVariable methodsFor: 'testing' stamp: 'cwp 5/16/2004 20:05'!
isInstanceVariable
	^ true! !

!CMVariable methodsFor: 'accessing' stamp: 'cwp 5/15/2004 22:42'!
name
	^ name! !

!CMVariable methodsFor: 'accessing' stamp: 'cwp 5/15/2004 22:49'!
name: aSymbol
	name _ aSymbol! !

!CMVariable methodsFor: 'copying' stamp: 'cwp 6/8/2004 20:58'!
deepCopy
	^ super deepCopy name: self name! !

CMVariable subclass: #CMPoolImport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMPoolImport methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:59'!
acceptGuide: aGuide
	aGuide visitPoolImport: self! !

CMVariable subclass: #CMSharedVariable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

!CMSharedVariable methodsFor: 'testing' stamp: 'cwp 5/16/2004 22:23'!
isClassVariable
	^ parent isClass! !

!CMSharedVariable methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:00'!
acceptGuide: aGuide
	aGuide visitSharedVariable: self! !

!CMNode methodsFor: 'testing' stamp: 'cwp 7/20/2004 13:44'!
isMetaclassSegment
	^false! !

!CMNode methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:02'!
isSequence
	^ false! !

Object subclass: #CMClassBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Environment'!

!CMClassBuilder methodsFor: 'message building' stamp: 'cwp 6/6/2004 20:43'!
selectorForFormat: aSymbol
	^ ((self selectorPartForFormat: aSymbol), 
		'instanceVariableNames:classVariableNames:poolDictionaries:category:')
			asSymbol! !

!CMClassBuilder methodsFor: 'message building' stamp: 'cwp 6/6/2004 20:45'!
selectorPartForFormat: aSymbol
	#(bytes subclass: words variableWordSubclass: 
	weak weakSubclass: variable variableByteSubclass:)
		pairsDo: [:type :part | type = aSymbol ifTrue: [^ part]].
	^ #subclass:
! !

!CMClassBuilder methodsFor: 'intalling' stamp: 'cwp 6/7/2004 16:26'!
install: node
	| superclass selector |
	superclass _ self classNamed: node superName asSymbol.
	selector _ self selectorForFormat: node format.
	superclass 
		perform: selector
		withArguments: (Array
						with: node name
						with: (self stringForNames: node instanceVariables)
						with: (self stringForNames: node classVariables)
						with: (self stringForNames: node poolImports)
						with: (self categoryForClass: node))! !

!CMClassBuilder methodsFor: 'message building' stamp: 'cwp 6/7/2004 16:27'!
categoryForClass: node
	^ (PackageInfo named: node parent name)
		longNameOf: node category! !

!CMClassBuilder methodsFor: 'message building' stamp: 'cwp 6/6/2004 21:39'!
classNamed: aSymbol 
	^ Smalltalk at: aSymbol ifAbsent: [self signalFailure: aSymbol, ' doesn''t exist']! !

!CMClassBuilder methodsFor: 'message building' stamp: 'cwp 6/6/2004 20:35'!
stringForNames: variables
	^ String streamContents: 
		[:stream |
		variables 
			do: [:ea | stream nextPutAll: ea name]
			separatedBy: [stream nextPut: $ ]]		! !

Object subclass: #CMNullPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Utilities'!

!CMNullPackage methodsFor: 'testing' stamp: 'cwp 8/12/2004 21:40'!
isLibrary
	^ false! !

!CMNullPackage methodsFor: 'accessing' stamp: 'cwp 8/12/2004 21:39'!
classNamed: aSymbol 
	^ (CMClass fromBaseClass: (Smalltalk at: aSymbol ifAbsent: [^ nil]))
		parent: self! !

Object subclass: #CMVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 7/20/2004 13:47'!
visitClassSegment: aNode 
	self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:10'!
visitToken: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:39'!
visitSharedVariable: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 7/20/2004 13:48'!
visitMetaclassSegment: aNode 
	self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitBlock: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:23'!
visitArgument: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitReturn: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:03'!
visitAnnotation: aNode
	self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitInstanceVariable: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitMessage: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitCascade: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitPoolImport: aNode
	^ self visitNode: aNode! !

CMVisitor subclass: #CMSourcePrinter
	instanceVariableNames: 'stream hidden'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMSourcePrinter class methodsFor: 'printing' stamp: 'cwp 5/31/2004 12:04'!
print: aNode
	| stream |
	stream _ WriteStream on: (String new: 100).
	self print: aNode on: stream.
	^ stream contents! !

!CMSourcePrinter methodsFor: 'visiting' stamp: 'cwp 6/19/2004 14:15'!
visitAnnotation: annotation
	annotation isInvisible ifTrue: [hidden _ annotation]! !

!CMSourcePrinter methodsFor: 'printing' stamp: 'cwp 6/19/2004 14:25'!
shouldHide: aToken
	| shouldHide |
	hidden ifNil: [^ false].
	shouldHide _ aToken descendsFrom: hidden.
	shouldHide ifFalse: [hidden _ nil].
	^ shouldHide! !

!CMSourcePrinter methodsFor: 'accessing' stamp: 'cwp 5/25/2004 00:35'!
stream: aStream
	stream _ aStream! !

!CMSourcePrinter class methodsFor: 'printing' stamp: 'cwp 5/25/2004 00:34'!
print: aNode on: aStream
	| printer |
	printer _ self new.
	printer stream: aStream.
	printer print: aNode! !

!CMSourcePrinter methodsFor: 'visiting' stamp: 'cwp 6/19/2004 14:16'!
visitToken: aToken
	(self shouldHide: aToken)
		ifFalse: [stream nextPutAll: aToken whitespace.
				stream nextPutAll: aToken value]! !

!CMSourcePrinter methodsFor: 'printing' stamp: 'cwp 6/19/2004 13:41'!
print: aNode 
	CMPreOrderGuide guide: self through: aNode.
! !

CMVisitor subclass: #CMPluggableVisitor
	instanceVariableNames: 'root guide block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMPluggableVisitor methodsFor: 'initializing' stamp: 'cwp 6/5/2004 19:51'!
setRoot: aNode guide: aGuide
	root _ aNode.
	guide _ aGuide.
	guide visitor: self.! !

!CMPluggableVisitor methodsFor: 'enumerating' stamp: 'cwp 6/5/2004 19:42'!
do: aBlock
	block _ aBlock.
	guide visit: root! !

!CMPluggableVisitor methodsFor: 'enumerating' stamp: 'cwp 7/7/2004 16:38'!
select: aBlock 
	"Copied from Collection"

	| newCollection |
	newCollection _ OrderedCollection new.
	self do: [:each | (aBlock value: each) ifTrue: [newCollection add: each]].
	^newCollection! !

!CMPluggableVisitor methodsFor: 'enumerating' stamp: 'cwp 6/5/2004 19:43'!
detect: aBlock ifNone: exceptionBlock 
	"Copied from collection. I wish we had Traits already."

	self do: [:each | (aBlock value: each) ifTrue: [^ each]].
	^ exceptionBlock value! !

!CMPluggableVisitor class methodsFor: 'instance creation' stamp: 'cwp 6/5/2004 19:38'!
root: aNode guide: aGuide
	^ self new setRoot: aNode guide: aGuide! !

!CMPluggableVisitor methodsFor: 'visiting' stamp: 'cwp 6/5/2004 19:41'!
visitNode: aNode
	^ block value: aNode! !

!CMPluggableVisitor methodsFor: 'enumerating' stamp: 'cwp 7/8/2004 10:57'!
do: aBlock without: anItem 
	"Copied from Collection"

	^ self do: [:each | anItem = each ifFalse: [aBlock value: each]]! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitLiteral: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:27'!
visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitMethod: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 7/7/2004 19:55'!
visitBundle: aCMBundle 
	self visitNode: aCMBundle! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:39'!
visitVariableReference: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitArray: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitPackage: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:38'!
visitSequence: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitClass: aNode
	^ self visitNode: aNode! !

!CMVisitor methodsFor: 'visiting' stamp: 'cwp 5/25/2004 00:37'!
visitAssignment: aNode
	^ self visitNode: aNode! !

Object subclass: #CMClassFormat
	instanceVariableNames: 'bits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Utilities'!

!CMClassFormat commentStamp: 'cwp 9/25/2004 16:07' prior: 0!
I am an expert on the way the Squeak VM encodes class formats. My instance variable, 'bits', is identical in format to the 'format' instance variable of Behavior. I have methods for interpreting those bits. The class format integer is 18 bits in length. The instSize field is split into two parts for backwards compatibility.

<2 bits=instSize//64> <5 bits=cClass> <4 bits=instSpec> <6 bits=instSize\\64> <1 bit=0>

- instSize: the number of named instance variables
- cClass: the index into the compact class table
- instSpec: values indicating how instances are organized
	0 - no state
	1 - named instance variables only
	2 - variable number of object pointers
	3 - named instance variables, variable number of object pointers
	4 - variable number of weak object pointers
	6 - variable number of words
	8 - variable number of bytes!

!CMClassFormat class methodsFor: 'computing' stamp: 'cwp 9/25/2004 14:03'!
bitsForCount: count instSpec: instSpec cClassIndex: cClassIndex
	"Based on ClassBuilder>>format:variable:words:pointers:weak - ar 7/11/1999 06:39 "

	| bits |
	bits _ (count+1) // 64. 	
	bits _ (bits bitShift: 5) + cClassIndex.
	bits _ (bits bitShift: 4) + instSpec.
	bits _ (bits bitShift: 6) + ((count+1)\\64).  "+1 since prim count field includes header"
	bits _ (bits bitShift: 1). "This shift plus integer bit lets wordSize work like byteSize"
	^ bits! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 15:08'!
fixed
	^ self fixed: 0! !

!CMClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:49'!
isWords
	"Answer whether the receiver has 32-bit instance variables."

	^ self isBytes not! !

!CMClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isWeak
	"Answer whether the receiver has contains weak references."
	^ self instSpec = 4! !

!CMClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isPointers
	"Answer whether the receiver contains just pointers (not bits)."

	^self isBits not! !

!CMClassFormat class methodsFor: 'computing' stamp: 'cwp 9/25/2004 14:00'!
bitsForCount: count isVariable: isVariable isWords: isWords isPointers: isPointers isWeak: isWeak
	"Based on ClassBuilder>>format:variable:words:pointers:weak - ar 7/11/1999 06:39 "

	|  instSpec  |
	instSpec _ isWeak
		ifTrue:[4]
		ifFalse:[isPointers
				ifTrue: [isVariable
						ifTrue: [count>0 ifTrue: [3] ifFalse: [2]]
						ifFalse: [count>0 ifTrue: [1] ifFalse: [0]]]
				ifFalse: [isWords ifTrue: [6] ifFalse: [8]]].
		
	^ self bitsForCount: count instSpec: instSpec cClassIndex: 0! !

!CMClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isFixed
	"Answer whether the receiver does not have a variable (indexable) part."

	^self isVariable not! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 14:45'!
bytes
	^ self bytes: 0! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 14:33'!
variable
	^ self variable: 0! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 14:33'!
bytes: size
	^ self fixed: size isVariable: true isWords: false isPointers: false isWeak: false! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 14:42'!
weak
	^ self fixed: 0 isVariable: true isWords: true isPointers: true isWeak: true! !

!CMClassFormat methodsFor: 'accessing' stamp: 'cwp 9/25/2004 13:49'!
instSpec
	^ (bits bitShift: -7) bitAnd: 16rF! !

!CMClassFormat methodsFor: 'accessing' stamp: 'cwp 9/25/2004 13:43'!
bits
	^bits! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 14:35'!
words
	^ self words: 0! !

!CMClassFormat methodsFor: 'accessing' stamp: 'cwp 9/25/2004 13:43'!
bits: anObject
	bits := anObject! !

!CMClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isBytes
	"Answer whether the receiver has 8-bit instance variables."

	^ self instSpec >= 8! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 14:05'!
fixed: count isVariable: isVariable isWords: isWords isPointers: isPointers isWeak: isWeak
	^ self fromBits: (self 
						bitsForCount: count 
						isVariable: isVariable 
						isWords: isWords 
						isPointers: isPointers 
						isWeak: isWeak)! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 14:32'!
variable: size
	^ self fixed: size isVariable: true isWords: false isPointers: true isWeak: false! !

!CMClassFormat methodsFor: 'accessing' stamp: 'cwp 9/25/2004 13:47'!
instSize
	^ ((bits bitShift: -10) bitAnd: 16rC0) + ((bits bitShift: -1) bitAnd: 16r3F) - 1! !

!CMClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:47'!
isBits
	"Answer whether the receiver contains just bits (not pointers)."

	^ self instSpec >= 6! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 14:32'!
fixed: size
	^ self fixed: size isVariable: false isWords: false isPointers: true isWeak: false! !

!CMClassFormat methodsFor: 'testing' stamp: 'cwp 9/25/2004 13:48'!
isVariable
	"Answer whether the receiver has indexable variables."

	^ self instSpec >= 2! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 13:44'!
fromBits: bits
	^ self new bits: bits! !

!CMClassFormat class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 14:35'!
words: size
	^ self fixed: size isVariable: true isWords: true isPointers: false isWeak: false! !

Object subclass: #CMLibrary
	instanceVariableNames: 'packages notifier'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Environment'!

!CMLibrary methodsFor: 'accessing' stamp: 'cwp 8/14/2004 22:50'!
bundle
	| bundle |
	bundle _ CMBundle new.
	packages values do: [:ea | bundle addPackage: ea].
	^ bundle! !

!CMLibrary methodsFor: 'accessing' stamp: 'cwp 8/14/2004 22:35'!
at: packageName put: aPackage
	packages ifNil: [packages _ Dictionary new].
	packages at: packageName put: aPackage.
	aPackage parent: self! !

!CMLibrary class methodsFor: 'as yet unclassified' stamp: 'cwp 8/14/2004 22:17'!
importPackageInfoNotifying: progress
	| library quantum |
	library := CMLibrary new.
	quantum := PackageOrganizer default packages size reciprocal.
	PackageOrganizer default packages 
		do: [:ea | 
			progress subLabel: ea packageName.
			library 
				at: ea packageName asSymbol 
				put:  (CMPackageImporter importFromPackageInfo: ea).
			progress incrDone: quantum].
	Smalltalk at: #Library put: library! !

!CMLibrary class methodsFor: 'as yet unclassified' stamp: 'cwp 7/5/2004 16:21'!
initFromPackageInfo
	| progress |
	progress _ ProgressMorph label: 'Importing Packages'.
	progress openInWorld.
	[self importPackageInfoNotifying: progress.
	progress delete] 
		fork
! !

!CMLibrary methodsFor: 'accessing' stamp: 'cwp 8/14/2004 22:28'!
at: packageName
	^ packages at: packageName! !

!CMLibrary methodsFor: 'accessing' stamp: 'cwp 8/14/2004 22:42'!
notifier
	^ notifier ! !

!CMLibrary methodsFor: 'initializing' stamp: 'cwp 8/17/2004 22:25'!
initialize
	notifier _ CMChangeNotifier basicNew initialize! !

!CMLibrary methodsFor: 'testing' stamp: 'cwp 6/15/2004 23:12'!
isLibrary
	^ true! !

Object subclass: #CMBehavior
	instanceVariableNames: 'superclass methodDict format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Model'!

CMBehavior class
	instanceVariableNames: 'cateogry'!

!CMBehavior commentStamp: 'cwp 9/20/2004 01:20' prior: 0!
CMBehavior is a lightweight replacement for Behavior, with just the essential methods.

#literalScannedAs:notifying: should be implemented somewhere else, but this will probably not be an issue with the new ClosureCompiler.!

!CMBehavior methodsFor: 'accessing' stamp: ''!
allInstVarNames
	"Answer an Array of the names of the receiver's instance variables. The 
	Array ordering is the order in which the variables are stored and 
	accessed by the interpreter."

	| vars |
	superclass == nil
		ifTrue: [vars _ self instVarNames copy]	"Guarantee a copy is answered."
		ifFalse: [vars _ superclass allInstVarNames , self instVarNames].
	^vars! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 9/19/2004 18:55'!
superclass
	^superclass! !

!CMBehavior methodsFor: 'method dictionary' stamp: 'rw 5/12/2003 11:19'!
selectorAtMethod: method setClass: classResultBlock 
	"Answer both the message selector associated with the compiled method 
	and the class in which that selector is defined."

	| sel |
	sel _ self methodDict keyAtIdentityValue: method
				ifAbsent: 
					[superclass == nil
						ifTrue: 
							[classResultBlock value: self.
							^method defaultSelector].
					sel _ superclass selectorAtMethod: method setClass: classResultBlock.
					"Set class to be self, rather than that returned from 
					superclass. "
					sel == method defaultSelector ifTrue: [classResultBlock value: self].
					^sel].
	classResultBlock value: self.
	^sel! !

!CMBehavior methodsFor: 'instance creation' stamp: 'sd 3/28/2003 15:06'!
basicNew
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	indexable variables. Fail if the class is indexable. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 70>
	self isVariable ifTrue: [ ^ self basicNew: 0 ].
	"space must be low"
	self environment signalLowSpace.
	^ self basicNew  "retry if user proceeds"
! !

!CMBehavior methodsFor: 'testing' stamp: 'cwp 9/25/2004 14:55'!
isVariable
	^ self instFormat isVariable! !

!CMBehavior methodsFor: 'testing' stamp: 'cwp 9/25/2004 14:56'!
isWords
	^ self instFormat isWords! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 9/19/2004 19:49'!
methodDict: aMethodDictionary 
	methodDict := aMethodDictionary! !

!CMBehavior class methodsFor: 'transition' stamp: 'cwp 9/19/2004 20:49'!
steal: aSelector
	| oldMethod newMethod |
	category _ Behavior organization categoryOfElement: aSelector.
	oldMethod _ Behavior compiledMethodAt: aSelector.
	newMethod _ oldMethod copyWithTrailerBytes: oldMethod trailer.
	newMethod
		putSource: oldMethod getSourceFromFile
		fromParseNode: nil
		class: self
		category: category
		withStamp: oldMethod timeStamp
		inFile: 2 
		priorMethod: oldMethod.
	self addSelector: aSelector withMethod: newMethod.
	self organization classify: aSelector under: category! !

!CMBehavior methodsFor: 'method dictionary' stamp: 'di 3/27/1999 23:20'!
includesSelector: aSymbol 
	"Answer whether the message whose selector is the argument is in the 
	method dictionary of the receiver's class."

	^ self methodDict includesKey: aSymbol! !

!CMBehavior methodsFor: 'initializing' stamp: 'cwp 9/19/2004 19:49'!
setSuperclass: aClass format: aFormat 
	superclass := aClass.
	format := aFormat.
	methodDict := MethodDictionary new! !

!CMBehavior methodsFor: 'accessing' stamp: ''!
instVarNames
	"Answer an Array of the instance variable names. Behaviors must make 
	up fake local instance variable names because Behaviors have instance 
	variables for the purpose of compiling methods, but these are not named 
	instance variables."

	| mySize superSize |
	mySize _ self instSize.
	superSize _ 
		superclass == nil
			ifTrue: [0]
			ifFalse: [superclass instSize].
	mySize = superSize ifTrue: [^#()].	
	^(superSize + 1 to: mySize) collect: [:i | 'inst' , i printString]! !

!CMBehavior methodsFor: 'instance creation' stamp: 'cwp 9/19/2004 19:02'!
new: size
	^ (self basicNew: size) initialize! !

!CMBehavior methodsFor: 'testing' stamp: 'cwp 9/25/2004 14:55'!
isPointers
	^ self instFormat isPointers! !

!CMBehavior methodsFor: 'testing' stamp: 'cwp 9/25/2004 14:56'!
isWeak
	^ self instFormat isWeak! !

!CMBehavior class methodsFor: 'instance creation' stamp: 'cwp 9/25/2004 15:01'!
superclass: aClass format: aClassFormat
	^ self new setSuperclass: aClass format: aClassFormat bits! !

!CMBehavior methodsFor: 'testing' stamp: 'cwp 9/25/2004 14:55'!
isFixed
	^ self instFormat isFixed! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 9/19/2004 20:02'!
methodDict
	^ methodDict! !

!CMBehavior methodsFor: 'instance creation' stamp: 'sd 3/28/2003 15:06'!
basicNew: sizeRequested 
	"Primitive. Answer an instance of this class with the number
	of indexable variables specified by the argument, sizeRequested.
	Fail if this class is not indexable or if the argument is not a
	positive Integer, or if there is not enough memory available. 
	Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	self isVariable ifFalse:
		[self error: self printString, ' cannot have variable sized instances'].
	(sizeRequested isInteger and: [sizeRequested >= 0]) ifTrue:
		["arg okay; space must be low."
		self environment signalLowSpace.
		^ self basicNew: sizeRequested  "retry if user proceeds"].
	self primitiveFailed! !

!CMBehavior methodsFor: 'instance creation' stamp: 'cwp 9/19/2004 18:47'!
new
	^ self basicNew initialize! !

!CMBehavior methodsFor: 'testing' stamp: 'ab 3/12/2003 17:44'!
isMeta
	^ false! !

!CMBehavior methodsFor: 'method dictionary' stamp: 'di 1/2/1999 15:45'!
lookupSelector: selector
	"Look up the given selector in my methodDictionary.
	Return the corresponding method if found.
	Otherwise chase the superclass chain and try again.
	Return nil if no method is found."
	| lookupClass |
	lookupClass _ self.
	[lookupClass == nil]
		whileFalse: 
			[(lookupClass includesSelector: selector)
				ifTrue: [^ lookupClass compiledMethodAt: selector].
			lookupClass _ lookupClass superclass].
	^ nil! !

!CMBehavior methodsFor: 'testing' stamp: 'cwp 9/25/2004 14:54'!
isBytes
	^ self instFormat isBytes! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 9/19/2004 18:50'!
format
	^format! !

!CMBehavior methodsFor: 'testing' stamp: 'cwp 9/19/2004 19:17'!
shouldNotBeRedefined
	^ true! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 9/25/2004 14:52'!
instFormat
	"Evenutally this should replace #format"

	^ CMClassFormat fromBits: format! !

!CMBehavior methodsFor: 'testing' stamp: 'cwp 9/25/2004 14:54'!
isBits
	^ self instFormat isBits! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 9/25/2004 14:53'!
instSpec
	^ self instFormat instSpec! !

!CMBehavior methodsFor: 'printing' stamp: 'ar 5/17/2003 14:11'!
literalScannedAs: scannedLiteral notifying: requestor
	"Postprocesses a literal scanned by Scanner scanToken (esp. xLitQuote).
	If scannedLiteral is not an association, answer it.
	Else, if it is of the form:
		nil->#NameOfMetaclass
	answer nil->theMetaclass, if any has that name, else report an error.
	Else, if it is of the form:
		#NameOfGlobalVariable->anythiEng
	answer the global, class, or pool association with that nameE, if any, else
	add it to Undeclared a answer the new Association."

	| key value |
	(scannedLiteral isVariableBinding)
		ifFalse: [^ scannedLiteral].
	key _ scannedLiteral key.
	value _ scannedLiteral value.
	key isNil 
		ifTrue: "###<metaclass soleInstance name>"
			[(self bindingOf: value) ifNotNilDo:[:assoc|
				 (assoc value isKindOf: Behavior)
					ifTrue: [^ nil->assoc value class]].
			 requestor notify: 'No such metaclass'.
			 ^false].
	(key isMemberOf: Symbol)
		ifTrue: "##<global var name>"
			[(self bindingOf: key) ifNotNilDo:[:assoc | ^assoc].
			Undeclared at: key put: nil.
			 ^Undeclared bindingOf: key].
	requestor notify: '## must be followed by a non-local variable name'.
	^false

"	Form literalScannedAs: 14 notifying: nil 14
	Form literalScannedAs: #OneBitForm notiEfying: nil  OneBitForm
	Form literalScannedAs: ##OneBitForm notifying: nil  OneBitForm->a Form
	Form literalScannedAs: ##Form notifying: nil   Form->Form
	Form literalScannedAs: ###Form notifying: nil   nilE->Form class
"! !

!CMBehavior methodsFor: 'method dictionary' stamp: 'cwp 9/19/2004 20:08'!
addSelector: selector withMethod: compiledMethod 
	"Add the message selector with the corresponding compiled method to the 
	receiver's method dictionary. Do this without sending system change notifications"

	| oldMethodOrNil |
	oldMethodOrNil _ self lookupSelector: selector.
	self methodDict at: selector put: compiledMethod.

	"Now flush Squeak's method cache, either by selector or by method"
	oldMethodOrNil == nil ifFalse: [oldMethodOrNil flushCache].
	selector flushCache.! !

!CMBehavior methodsFor: 'testing' stamp: 'cwp 9/19/2004 19:17'!
isBehavior
	^ true! !

!CMBehavior methodsFor: 'accessing' stamp: 'cwp 9/25/2004 14:52'!
instSize
	^ self instFormat instSize! !

!CMBehavior methodsFor: 'hooks' stamp: 'cwp 9/19/2004 20:10'!
compilerClass
	^ Compiler! !

Object subclass: #CMGuide
	instanceVariableNames: 'visitor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitReturn: aNode
	visitor visitReturn: aNode! !

!CMGuide methodsFor: 'private' stamp: 'cwp 6/19/2004 12:11'!
visitStatements: statements andPeriods: periods
	periods ifNil: [statements do: [:ea | self visit: ea] separatedBy: [visitor visitToken: self period]. 
					^ self].
			
	1 to: periods size do: [:i | 
						self visit: (statements at: i).
						self visitToken: (periods at: i)].
	statements size > periods size ifTrue: [self visit: statements last]! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 6/18/2004 21:57'!
visitPool: aNode
	visitor visitPool: aNode
	! !

CMGuide subclass: #CMClassGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMClassGuide methodsFor: 'visiting' stamp: 'cwp 6/5/2004 20:35'!
visitPackage: aNode
	aNode classes do: [:ea | self visitClass: ea]! !

!CMClassGuide methodsFor: 'visiting' stamp: 'cwp 6/5/2004 20:40'!
visitBundle: aNode
	aNode packages do: [:ea | self visitPackage: ea]! !

!CMClassGuide methodsFor: 'visiting' stamp: 'cwp 6/5/2004 20:48'!
visitClass: aNode
	^ visitor visitClass: aNode! !

CMClassGuide subclass: #CMMethodGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMMethodGuide methodsFor: 'as yet unclassified' stamp: 'cwp 6/7/2004 13:57'!
visitMethod: aNode
	visitor visitMethod: aNode! !

!CMMethodGuide methodsFor: 'as yet unclassified' stamp: 'cwp 6/7/2004 13:57'!
visitClass: aNode
	aNode methods do: [:ea | self visitMethod: ea]! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:22'!
visitAssignment: aNode
	visitor visitAssignment: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:11'!
visitNode: aNode
	visitor visitNode: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/26/2004 15:04'!
visitAnnotation: aNode
	visitor visitAnnotation: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitSharedVariable: aNode
	visitor visitSharedVariable: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 15:49'!
visitToken: aToken
	aToken ifNotNil: [visitor visitToken: aToken]! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 6/18/2004 21:59'!
visitClass: aNode
	visitor visitClass: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitSequence: aNode
	visitor visitSequence: aNode! !

!CMGuide methodsFor: 'private' stamp: 'cwp 6/19/2004 12:07'!
visitValue: value in: aBlock
	self visitToken: value leftParen.
	aBlock value.
	self visitToken: value rightParen! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:27'!
visitVariableReference: aNode
	visitor visitVariableReference: aNode! !

CMGuide subclass: #CMPreOrderGuide
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Iterators'!

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:08'!
visitLiteral: aNode
	visitor visitLiteral: aNode.
	self visitValue: aNode in: [self visitToken: aNode token]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 13:38'!
visitVariableReference: aNode
	visitor visitVariableReference: aNode.
	self visitValue: aNode in: [self visitToken: aNode identifier].! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 13:20'!
visitArgument: aNode
	visitor visitArgument: aNode.
	aNode hasColon ifTrue: [self visitToken: aNode colon].
	self visitToken: aNode identifier. ! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:33'!
visitBinaryMessagePattern: pattern
	self visitToken: pattern selectorParts first.
	self visit: pattern arguments first! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 14:39'!
visitCascade: aNode
	visitor visitCascade: aNode.
	self visit: aNode messages first.
	1 	to: aNode semicolons size 
		do: [:i | | semicolon message |
			semicolon _ (aNode semicolons at: i).
			message _ (aNode messages at: i + 1).
			self visitToken: semicolon.
			self visitMessage: message]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 7/20/2004 13:40'!
visitPackage: aNode 
	visitor visitPackage: aNode.
	aNode classes do: [:ea | self visitClass: ea].
	aNode segments do: [:ea | self visit: ea].
	aNode globals do: [:ea | self visitSharedVariable: ea].
	aNode pools do: [:ea | self visitPool: ea].
	aNode initializer ifNotNilDo: [:seq | self visitSequence: seq]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 7/20/2004 13:48'!
visitMetaclassSegment: aNode 
	visitor visitMetaclassSegment: aNode.
	self visitExtension: aNode! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:47'!
visitBlock: aNode
	visitor visitBlock: aNode.
	self visitValue: aNode
		in: [self visitToken: aNode leftBracket.
			aNode arguments do: [:ea | self visitArgument: ea].
			aNode hasBar ifTrue: [self visitToken: aNode bar].
			self visitSequence: aNode body.
			self visitToken: aNode rightBracket]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:02'!
visitStatementList: aNode
	self visitStatements: aNode statements andPeriods: aNode periods.! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:33'!
visitMessagePattern: messagePattern
	messagePattern isUnary ifTrue: [^ self visitUnaryMessagePattern: messagePattern].
	messagePattern isBinary ifTrue: [^ self visitBinaryMessagePattern: messagePattern].
	messagePattern isKeyword ifTrue: [^ self visitKeywordMessagePattern: messagePattern]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:26'!
visitAssignment: aNode
	visitor visitAssignment: aNode.
	self visitValue: aNode in: [self visit: aNode variable.
							self visitToken: aNode operator.
							self visit: aNode value]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:02'!
visitSequence: aNode
	visitor visitSequence: aNode.
	aNode hasBars ifTrue: [self visitToken: aNode leftBar].
	aNode temporaries do: [:ea | self visitVariableReference: ea].
	aNode hasBars ifTrue: [self visitToken: aNode rightBar].
	self visitStatementList: aNode! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 13:47'!
visitMethod: aNode
	visitor visitMethod: aNode.
	self visitMessagePattern: aNode.
	aNode annotations do: [:ea | self visitAnnotation: ea].
	self visitSequence: aNode body.! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:13'!
visitArray: aNode
	visitor visitArray: aNode.
	aNode hasBraces ifTrue: [self visitToken: aNode leftBrace].
	self visitStatementList: aNode.
	aNode hasBraces ifTrue: [self visitToken: aNode rightBrace]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 13:43'!
visitUnaryMessagePattern: pattern
	self visitToken: pattern selectorParts first! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 7/20/2004 13:47'!
visitClassSegment: aNode 
	visitor visitClassSegment: aNode.
	self visitExtension: aNode.
	aNode classVariables do: [:ea | visitor visitSharedVariable: ea].
	aNode poolImports do: [:ea | visitor visitPoolImport: ea].
	aNode initializer ifNotNilDo: [:node | visitor visitSequence: node]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 7/19/2004 19:31'!
visitClass: aNode
	visitor visitClass: aNode	! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 13:32'!
visitReturn: aNode
	visitor visitReturn: aNode.
	self visitToken: aNode return.
	self visit: aNode value.! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 14:53'!
visitMessage: aNode
	visitor visitMessage: aNode.
	self visitValue: aNode
		in: [aNode isCascaded ifFalse: [self visit: aNode receiver].
			self visitMessageParts: aNode selectorParts andArguments: aNode arguments]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:35'!
visitKeywordMessagePattern: pattern
	pattern selectorParts 
				with: pattern arguments
				do: [:part :arg | self visitToken: part. self visit: arg]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 7/19/2004 19:32'!
visitExtension: aNode
	aNode instanceVariables do: [:ea | visitor visitInstanceVariable: ea].
	aNode methods do: [:ea | self visitMethod: ea].
	aNode annotations do: [:ea | visitor visitAnnotation: ea].! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/19/2004 12:36'!
visitAnnotation: aNode
	visitor visitAnnotation: aNode.
	self visitValue: aNode in: [self visitMessagePattern: aNode]! !

!CMPreOrderGuide methodsFor: 'visiting' stamp: 'cwp 6/18/2004 21:53'!
visitBundle: aNode 
	visitor visitBundle: aNode.
	aNode packages do: [:ea | self visitPackage: ea]! !

!CMGuide methodsFor: 'accessing' stamp: 'cwp 5/25/2004 00:47'!
visitor: aVisitor
	visitor _ aVisitor! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:25'!
visitMethod: aNode
	visitor visitMethod: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitInstanceVariable: aNode
	visitor visitInstanceVariable: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitLiteral: aNode
	visitor visitLiteral: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/31/2004 21:55'!
visitMetaclass: aMetaclass
	visitor visitMetaclass: aMetaclass! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitCascade: aNode
	visitor visitCascade: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitPoolImport: aNode
	visitor visitPoolImport: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:22'!
visitArray: aNode
	visitor visitArray: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 14:23'!
visitArgument: anArgument
	visitor visitArgument: anArgument! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 6/18/2004 21:50'!
visitBundle: aNode
	visitor visitBundle: aNode! !

!CMGuide class methodsFor: 'guiding' stamp: 'cwp 5/25/2004 01:01'!
guide: aVisitor through: aNode
	| guide |
	guide _ self new.
	guide visitor: aVisitor.
	guide visit: aNode! !

!CMGuide methodsFor: 'guiding' stamp: 'cwp 5/25/2004 00:49'!
visit: aNode
	aNode acceptGuide: self! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:26'!
visitPackage: aNode
	visitor visitPackage: aNode! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:23'!
visitBlock: aNode
	visitor visitBlock: aNode! !

!CMGuide methodsFor: 'private' stamp: 'cwp 5/25/2004 02:37'!
visitMessageParts: parts andArguments: arguments
	parts size = 1
		ifTrue: [self visitToken: parts first.
				arguments isEmpty not ifTrue: [self visit: arguments first]]
		ifFalse: [parts with: arguments do: [:keyword :arg | 
											self visitToken: keyword. 
											self visit: arg]]! !

!CMGuide methodsFor: 'visiting' stamp: 'cwp 5/25/2004 01:24'!
visitMessage: aNode
	visitor visitMessage: aNode! !

Object subclass: #CMEnvironment
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Environment'!

!CMEnvironment class methodsFor: 'accessing' stamp: 'cwp 6/6/2004 21:37'!
current
	^ self new! !

!CMEnvironment methodsFor: 'installing' stamp: 'cwp 6/7/2004 16:38'!
installAnnotation: aNode
	aNode parent isClass 
		ifTrue: [self installClassAnnotation: aNode]
		ifFalse: [self installMethodAnnotation: aNode]! !

!CMEnvironment methodsFor: 'image' stamp: 'cwp 6/9/2004 13:11'!
packageNamed: aString 
	^ (CMPackageImporter import: aString)
		parent: self;
		yourself! !

!CMEnvironment methodsFor: 'installing' stamp: 'cwp 6/6/2004 22:51'!
installMethod: node 
	| source class |
	source _ CMSourcePrinter print: node.
	class _ Smalltalk at: node parent name asSymbol.
	class compile: source classified: node category.! !

!CMEnvironment methodsFor: 'removing' stamp: 'cwp 6/7/2004 00:07'!
removeClass: node
	(Smalltalk at: node name ifAbsent: [^ self]) removeFromSystem ! !

!CMEnvironment methodsFor: 'testing' stamp: 'cwp 6/4/2004 13:05'!
isEnvironment
	^ true! !

!CMEnvironment methodsFor: 'installing' stamp: 'cwp 6/7/2004 16:46'!
installClassComment: aNode
	(self classForNode: aNode parent) classComment: aNode arguments first value! !

!CMEnvironment methodsFor: 'installing' stamp: 'cwp 6/6/2004 19:17'!
installClass: aCMClass 
	CMClassBuilder new install: aCMClass! !

!CMEnvironment methodsFor: 'removing' stamp: 'cwp 6/7/2004 00:36'!
removeMethod: aCMMethod 
	(Smalltalk at: aCMMethod parent name) removeSelector: aCMMethod selector! !

!CMEnvironment methodsFor: 'installing' stamp: 'cwp 6/7/2004 16:45'!
installClassAnnotation: aNode
	aNode selector = #comment: ifTrue: [^ self installClassComment: aNode].
	aNode selector = #category: ifTrue: [^ self installClassCategory: aNode].! !

!CMEnvironment methodsFor: 'image' stamp: 'cwp 6/7/2004 16:41'!
classForNode: aClassNode
	^ Smalltalk at: aClassNode name ! !

SystemChangeNotifier subclass: #CMChangeNotifier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Notification'!

!CMChangeNotifier methodsFor: 'system triggers' stamp: 'cwp 8/20/2004 17:54'!
requestor: anObject replaced: oldNode with: newNode
	self trigger: (CMModifiedEvent old: oldNode new: newNode requestor: anObject)! !

!CMChangeNotifier methodsFor: 'private-event lists' stamp: 'cwp 8/19/2004 17:11'!
allSystemEvents
	^ self allItemKinds 
			gather: [:itemKind | 
					self allChangeKinds 
						collect: [:changeKind | 
								self systemEventsForItem: itemKind change: changeKind]]! !

!CMChangeNotifier class methodsFor: 'as yet unclassified' stamp: 'cwp 8/17/2004 23:32'!
initialize
	| source |
	source _ 'segmentKind
	^ #segment'.
	
	AbstractEvent class compile: source classified: 'item kinds'! !

!CMChangeNotifier methodsFor: 'private-event lists' stamp: 'cwp 8/19/2004 15:59'!
systemEventsForChange: changeKind
	^ self allItemKinds collect: [:itemKind | 
								  self systemEventsForItem: itemKind change: changeKind]! !

!CMChangeNotifier methodsFor: 'private-event lists' stamp: 'cwp 9/19/2004 18:32'!
allChangeKinds
	^ #(Added Modified Pruned)! !

!CMChangeNotifier methodsFor: 'private-event lists' stamp: 'cwp 8/19/2004 18:41'!
allItemKinds
	^ #(class segment annotation)! !

!CMChangeNotifier methodsFor: 'private-event lists' stamp: 'cwp 8/19/2004 15:59'!
systemEventsForItem: itemKind
	^ self allChangeKinds collect: [:changeKind | 
								  self systemEventsForItem: itemKind change: changeKind]! !

!CMChangeNotifier methodsFor: 'private-event lists' stamp: 'cwp 8/19/2004 15:58'!
systemEventsForItem: itemKind change: changeKind
	^ itemKind, changeKind asSymbol! !

!CMChangeNotifier methodsFor: 'system triggers' stamp: 'cwp 8/20/2004 17:52'!
requestor: anObject added: aNode
	self trigger: (CMAddedEvent item: aNode requestor: anObject)! !

!CMChangeNotifier methodsFor: 'system triggers' stamp: 'cwp 9/19/2004 18:25'!
requestor: anObject pruned: aNode
	self trigger: (CMPrunedEvent item: aNode requestor: anObject)! !

PackageInfo subclass: #CMPackageMirror
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Utilities'!

!CMPackageMirror methodsFor: 'listing' stamp: 'cwp 5/26/2004 16:46'!
classes
	^ model classes collect: [:ea | Smalltalk at: ea name]! !

!CMPackageMirror class methodsFor: 'as yet unclassified' stamp: 'cwp 5/26/2004 16:38'!
forInfo: aPackageInfo
	^ self new model: (CMPackageImporter importFromPackageInfo: aPackageInfo)! !

!CMPackageMirror methodsFor: 'accessing' stamp: 'cwp 5/26/2004 16:35'!
model: aPackageNode
	model _ aPackageNode! !

!CMPackageMirror methodsFor: 'accessing' stamp: 'cwp 5/26/2004 16:39'!
packageName
	^ model name! !

!CMPackageMirror methodsFor: 'listing' stamp: 'cwp 7/20/2004 13:40'!
methods
	| methods |
	methods := Set new.
	model segments 
		do: [:class | class methods do: [:m | methods add: m asMethodReference]].
	^methods asArray! !

TestResource subclass: #CMPackageResource
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPackageResource methodsFor: 'accessing' stamp: 'cwp 6/5/2004 22:26'!
importPackage
	^ CMPackageImporter import: self packageName! !

!CMPackageResource methodsFor: 'running' stamp: 'cwp 6/5/2004 22:24'!
setUp
	package _ self importPackage! !

CMPackageResource subclass: #CMBogusExtResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMBogusExtResource methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2004 06:53'!
packageName
	^ 'BogusExt'! !

CMPackageResource subclass: #CMBogusResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMBogusResource methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2004 06:53'!
packageName
	^ 'Bogus'! !

!CMPackageResource methodsFor: 'accessing' stamp: 'cwp 6/5/2004 22:53'!
package
	^ package! !

TestCase subclass: #CMPluggableVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPluggableVisitorTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/5/2004 20:53'!
testDetect
	| visitor class |
	visitor _ CMPluggableVisitor
				root: CMBogusResource current package
				guide: CMClassGuide new.
	class _ visitor 
		detect: [:ea | ea name = #BogusA]
		ifNone: [self signalFailure: 'BogusA not found'].
	self assert: class name = #BogusA.
	self assert: class isClass.! !

!CMPluggableVisitorTest methodsFor: 'as yet unclassified' stamp: 'cwp 6/5/2004 20:47'!
testDo
	| visitor |
	visitor _ CMPluggableVisitor
				root: CMBogusResource current package
				guide: CMClassGuide new.
	visitor do: [:ea | self assert: ea isClass]! !

!CMPluggableVisitorTest class methodsFor: 'as yet unclassified' stamp: 'cwp 6/5/2004 20:48'!
resources
	^ Array with: CMBogusResource ! !

!CMPluggableVisitorTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/7/2004 16:39'!
testSelect
	| visitor results |
	visitor _ CMPluggableVisitor
				root: CMBogusResource current package
				guide: CMClassGuide new.
	results _ visitor select: [:ea | ea name = #BogusA].
	self assert: results first name = #BogusA.
	self assert: results first isClass.
	self assert: results size = 1! !

TestCase subclass: #CMBehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMBehaviorTest methodsFor: 'tests' stamp: 'cwp 9/25/2004 15:15'!
testVariableNew
	| behavior instance |
	behavior := CMBehavior superclass: Object format: CMClassFormat variable.
	instance := behavior new: 1.
	self assert: instance class == behavior.
	self assert: instance size = 1! !

!CMBehaviorTest methodsFor: 'tests' stamp: 'cwp 9/25/2004 15:11'!
testInheritance
	| instance superclass subclass |
	superclass _ CMBehavior superclass: Object format: CMClassFormat fixed.
	self compile: 'one ^ 1' in: superclass.

	subclass _ CMBehavior superclass: superclass format: CMClassFormat fixed.
	instance _ subclass new.
	self assert: instance one = 1! !

!CMBehaviorTest methodsFor: 'tests' stamp: 'cwp 9/20/2004 23:36'!
testInstVarNames
	| behavior |
	behavior := CMBehavior new.
	behavior 
		setSuperclass: Object 
		format: (ClassBuilder new 
					format: 2 variable: false words: true  pointers: true  weak: false).
	self assert: behavior instVarNames = #('inst1' 'inst2')! !

!CMBehaviorTest methodsFor: 'tests' stamp: 'cwp 9/25/2004 15:14'!
testIsBehavior
	| behavior |
	behavior := CMBehavior superclass: Object format: CMClassFormat fixed.
	self deny: behavior isMeta.
	self assert: behavior isBehavior.
	self assert: behavior shouldNotBeRedefined! !

!CMBehaviorTest methodsFor: 'tests' stamp: 'cwp 9/25/2004 15:14'!
testMethod
	| behavior instance |
	behavior := CMBehavior superclass: Object format: CMClassFormat fixed.
	self compile: 'one ^ 1' in: behavior.
	instance := behavior new.
	self assert: instance one = 1! !

!CMBehaviorTest methodsFor: 'compiling' stamp: 'cwp 9/25/2004 15:16'!
compile: source in: behavior
	| method node |
	node _ behavior compilerClass new
				compile: source
				in: behavior
				notifying: nil
				ifFail: [self signalFailure: 'Compile failed'].
	method _ node generate: self class defaultMethodTrailer.
	behavior addSelector: node selector withMethod: method.
! !

!CMBehaviorTest methodsFor: 'tests' stamp: 'cwp 9/25/2004 15:14'!
testNew
	| behavior instance |
	behavior := CMBehavior superclass: Object format: CMClassFormat fixed.
	instance := behavior new.
	self assert: instance class == behavior! !

!CMBehaviorTest methodsFor: 'tests' stamp: 'cwp 9/25/2004 15:14'!
testMethodDict
	| behavior |
	behavior := CMBehavior superclass: Object format: CMClassFormat fixed.
	self assert: (behavior methodDict isKindOf: MethodDictionary)! !

TestCase subclass: #CMBundleTest
	instanceVariableNames: 'bundle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMBundleTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/8/2004 10:44'!
setUp
	| bogus ext |
	bogus _ CMPackageImporter import: 'Bogus'.
	ext _ CMPackageImporter import: 'BogusExt'.
	ext dependOn: bogus.
	bundle _ ext bundle.
! !

!CMBundleTest methodsFor: 'as yet unclassified' stamp: 'cwp 7/8/2004 10:46'!
testPackages
	self assert: ((bundle packages collect: [:ea | ea name]) includesAllOf: #('Bogus' 'BogusExt'))
! !

TestCase subclass: #CMClassFormatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMClassFormatTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2004 14:31'!
testVariable
	| format |
	format := CMClassFormat variable.
	self assert: format instSize = 0.
	self assert: format isPointers.
	self assert: format isWords.
	self assert: format isVariable.
	self deny: format isFixed.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak
! !

!CMClassFormatTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2004 14:44'!
testBytes
	| format |
	format := CMClassFormat bytes.
	self assert: format instSize = 0.
	self assert: format isVariable.
	self assert: format isBits.
	self assert: format isBytes.
	self deny: format isFixed.
	self deny: format isPointers.
	self deny: format isWords.
	self deny: format isWeak
! !

!CMClassFormatTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2004 14:44'!
testFixedAndBytes
	| format |
	format := CMClassFormat bytes: 4.
	self assert: format instSize = 4.
	self assert: format isVariable.
	self assert: format isBits.
	self assert: format isBytes.
	self deny: format isFixed.
	self deny: format isPointers.
	self deny: format isWords.
	self deny: format isWeak
! !

!CMClassFormatTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2004 14:45'!
testFixedAndPointers
	| format |
	format := CMClassFormat variable: 3.
	self assert: format instSize = 3.
	self assert: format isPointers.
	self assert: format isWords.
	self assert: format isVariable.
	self deny: format isFixed.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak
! !

!CMClassFormatTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2004 14:36'!
testFixedAndWords
	| format |
	format := CMClassFormat words: 4.
	self assert: format instSize = 4.
	self assert: format isVariable.
	self assert: format isBits.
	self assert: format isWords.
	self deny: format isFixed.
	self deny: format isPointers.
	self deny: format isBytes.
	self deny: format isWeak
! !

!CMClassFormatTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2004 14:43'!
testWeak
	| format |
	format := CMClassFormat weak.
	self assert: format instSize = 0.
	self assert: format isVariable.
	self assert: format isPointers.
	self assert: format isWords.
	self assert: format isWeak.
	self deny: format isFixed.
	self deny: format isBits.
	self deny: format isBytes.
! !

!CMClassFormatTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2004 14:36'!
testWords
	| format |
	format := CMClassFormat words.
	self assert: format instSize = 0.
	self assert: format isVariable.
	self assert: format isBits.
	self assert: format isWords.
	self deny: format isFixed.
	self deny: format isPointers.
	self deny: format isBytes.
	self deny: format isWeak
! !

!CMClassFormatTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2004 14:29'!
testNoState
	| format |
	format := CMClassFormat fixed: 0.
	self assert: format instSize = 0.
	self assert: format isFixed.
	self assert: format isPointers.
	self assert: format isWords.
	self deny: format isVariable.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak! !

!CMClassFormatTest methodsFor: 'as yet unclassified' stamp: 'cwp 9/25/2004 14:45'!
testFixed
	| format |
	format := CMClassFormat fixed: 3.
	self assert: format instSize = 3.
	self assert: format isFixed.
	self assert: format isPointers.
	self assert: format isWords.
	self deny: format isVariable.
	self deny: format isBits.
	self deny: format isBytes.
	self deny: format isWeak! !

TestCase subclass: #CMLibraryTest
	instanceVariableNames: 'library asserter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMLibraryTest methodsFor: 'running' stamp: 'cwp 8/14/2004 23:16'!
setUp
	library _ CMLibrary new.
	library at: #Bogus put: (CMPackageImporter import: 'Bogus').
	library notifier notify: self ofAllSystemChangesUsing: #event:! !

!CMLibraryTest methodsFor: 'tests' stamp: 'cwp 8/20/2004 23:34'!
testSegmentCategorized
	self 
		assert: [self bogusASegment category: 'Bogus-Base-X' requestor: self]
		event: [:event |
				self assert: event isModified.
				self assert: event item isAnnotation.
				self assert: event item parent = self bogusASegment.
				self assert: event oldItem isAnnotation.
				self assert: event oldItem parent isNil]
				! !

!CMLibraryTest methodsFor: 'tests' stamp: 'cwp 8/20/2004 23:33'!
testSegmentAdded
	| segment |
	segment _ self newClassSegment.
	self
		assert: [self bogusPackage defineSegment: segment requestor: self]
		event: [:event |
				self assert: event isAdded.
				self assert: event item == segment.
				self assert: event requestor == self]! !

!CMLibraryTest methodsFor: 'tests' stamp: 'cwp 8/20/2004 23:17'!
testClassRedefined
	| old new |
	old _ self bogusAClass.
	new _ old deepCopy.
	new superName: #ProtoObject.
	self 
		assert: [self bogusPackage defineClass: new requestor: self]
		event: [:event |		
				self assert: event isModified.
				self assert: event item == new.
				self assert: event oldItem == old.
				self assert: event requestor == self]
! !

!CMLibraryTest methodsFor: 'constants' stamp: 'cwp 8/20/2004 22:49'!
bogusASegment
	^self bogusPackage segments first! !

!CMLibraryTest methodsFor: 'tests' stamp: 'cwp 9/19/2004 18:32'!
testClassRemoved
	| class |
	class _ self bogusAClass.
	self 
		assert: [self bogusPackage removeClass: class requestor: self]
		event: [:event |
				self assert: event isPruned.
				self assert: event item == class.
				self assert: event requestor == self]! !

!CMLibraryTest methodsFor: 'tests' stamp: 'cwp 8/20/2004 23:35'!
testSegmentCommented
	self 
		assert: [self bogusASegment comment: 'A comment' requestor: self]
		event: [:event |
				self assert: event isModified.
				self assert: event item isAnnotation.
				self assert: event item parent = self bogusASegment.
				self assert: event oldItem isAnnotation.
				self assert: event oldItem parent isNil]
				! !

!CMLibraryTest methodsFor: 'constants' stamp: 'cwp 8/15/2004 17:00'!
bogusPackage
	^library at: #Bogus! !

!CMLibraryTest methodsFor: 'asserting' stamp: 'cwp 9/19/2004 18:30'!
assert: actionBlock event: assertionBlock
	asserter _ assertionBlock.
	actionBlock value.
	asserter _ nil! !

!CMLibraryTest methodsFor: 'tests' stamp: 'cwp 8/20/2004 23:35'!
testClassAdded
	| class |
	class _ self newClass.
	self 
		assert: [self bogusPackage defineClass: class requestor: self]
		event: [:event |
				self assert: event isAdded.
				self assert: event item == class.
				self assert: event requestor == self]! !

!CMLibraryTest methodsFor: 'constants' stamp: 'cwp 8/19/2004 18:53'!
newClassSegment
	^ (CMClassSegment named: #BogusD)
		category: #'Bogus-Base'! !

!CMLibraryTest methodsFor: 'callbacks' stamp: 'cwp 9/19/2004 18:24'!
event: anEvent
	asserter value: anEvent.
	asserter _ nil! !

!CMLibraryTest methodsFor: 'constants' stamp: 'cwp 8/20/2004 22:49'!
bogusAClass
	^self bogusPackage classes first! !

!CMLibraryTest methodsFor: 'constants' stamp: 'cwp 8/17/2004 22:35'!
newClass
	^ CMClass name: #BogusD superName: #Object! !

TestCase subclass: #CMPackageImportTest
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPackageImportTest methodsFor: 'testing' stamp: 'cwp 8/13/2004 21:44'!
testClasses
	package classes 
				with: BogusInfo classes 
				do: [:node :class | 
					self assert: (node refersTo: class).
					self assert: node parent == package.
					self assert: (node category = class category)]
	! !

!CMPackageImportTest methodsFor: 'testing' stamp: 'cwp 6/2/2004 19:09'!
testMethodAnnotations
	| annotations method |
	method _ package classes third methods first.
	annotations _ method annotations.
	annotations do: [:ea | self assert: ea parent == method.
						ea selectorParts do: [:part | self assert: part isToken].
						ea arguments do: [:arg | self assert: arg isLiteral]].
	self assert: (annotations collect: [:ea | ea selector]) asArray = #(category: author: timestamp:).
	self shouldnt: [DateAndTime fromString: annotations third arguments first value]
		raise: Exception! !

!CMPackageImportTest methodsFor: 'testing' stamp: 'cwp 7/19/2004 17:28'!
testPoolImports
	| pool class |
	class _ package classes second.
	pool _ class poolImports first.
	self assert: pool name = #BogusPool.
	self assert: pool parent parent = class parent.
	self assert: pool parent name == class name! !

!CMPackageImportTest methodsFor: 'testing' stamp: 'cwp 7/19/2004 17:20'!
testClassMethods
	self 
		assertMethodsIn: package classes first metacore
		match: BogusInfo classMethodsA! !

!CMPackageImportTest methodsFor: 'testing' stamp: 'cwp 7/19/2004 17:25'!
testInstanceVariables
	| ivars class |
	class _ package classes second.
	ivars _ class instanceVariables.
	self assert: ivars first name = #firstInstanceVariableB.
	self assert: ivars second name = #secondInstanceVariableB.
	self assert: ivars first parent name = class name.
	self assert: ivars second parent name = class name.! !

!CMPackageImportTest methodsFor: 'testing' stamp: 'cwp 7/19/2004 14:17'!
testClassInstVariables
	| civars metaclass |
	metaclass _ package classes second metacore.
	civars _ metaclass instanceVariables.
	self assert: civars first name = #firstClassInstanceVariableB.
	self assert: civars second name = #secondClassInstanceVariableB.
	self assert: civars first parent == metaclass.
	self assert: civars second parent == metaclass! !

!CMPackageImportTest class methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2004 06:54'!
resources
	^ Array with: CMBogusResource! !

!CMPackageImportTest methodsFor: 'testing' stamp: 'cwp 5/31/2004 20:07'!
testInstanceMethods
	self 
		assertMethodsIn: package classes first
		match: BogusInfo instanceMethodsA! !

!CMPackageImportTest methodsFor: 'testing' stamp: 'cwp 7/19/2004 17:21'!
testClassVariables
	| cvars extension |
	extension _ package classes second core.
	cvars _ extension classVariables.
	self assert: cvars first name = #FirstClassVariableB.
	self assert: cvars second name = #SecondClassVariableB.
	self assert: cvars first parent == extension.
	self assert: cvars second parent == extension.! !

!CMPackageImportTest methodsFor: 'asserting' stamp: 'cwp 7/19/2004 17:23'!
assertMethodsIn: class match: expected
	| methods |
	methods _ class methods.
	methods do: [:ea | 
				self assert: ea parent name = class name.
				self assert: ea isMethod].
	self assert: (methods collect: [:ea | ea selector]) asArray = expected
! !

!CMPackageImportTest methodsFor: 'running' stamp: 'cwp 6/3/2004 06:58'!
setUp
	package _ CMBogusResource current package! !

!CMPackageImportTest methodsFor: 'testing' stamp: 'cwp 7/19/2004 14:13'!
testClassComments
	self assert: package classes first comment = BogusInfo aComment.
	self assert: package classes second comment = ''! !

TestCase subclass: #CMParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:25'!
testLessThan
	"Test for potential conflict with annotation syntax"

	| root message |
	root _ self parseExpression: '3 < 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isLiteral.
	self assert: message selector = #<.
	self assert: message arguments first isLiteral.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:23'!
testBinarySymbolLiteral
	| root |
	root _ self parseExpression: '#+'.
	self assertLiteralExpression: root equals: #+! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:41'!
testFalseLiteral
	self assertLiteralParses: false! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:04'!
testBinaryMethod
	| root |
	root _ self parseMethod: '+ other ^ other'.
	self assert: root isMethod.
	self assert: root selector = #+.
	self assert: root body isSequence.
	self assert: root body leftBar isNil.
	self assert: root body rightBar isNil.! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:31'!
parseAnnotations: aString
	^ self parse: aString with: #parseAnnotations:! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testCharacterLiteral
	| root |
	root _ self parseExpression: '$g'.
	self assertLiteralExpression: root equals: $g! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testGreaterThan
	"Test for potential conflict with annotation syntax"

	| root message |
	root _ self parseExpression: '3 > 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isLiteral.
	self assert: message selector = #>.
	self assert: message arguments first isLiteral.! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:21'!
testEmptyMethod
	| root |
	root _ self parseMethod: 'foo'.
	self assert: root isMethod.
	self assert: root selector = #foo! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:27'!
testMethodWithTempsAndAnnotation2
	| root |
	root _ self parseMethod: '+ aNumber <primitive: 1> | foo bar |  ^ foo + bar'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:25'!
testKeywordSymbolLiteral
	| root |
	root _ self parseExpression: '#foo:'.
	self assertLiteralExpression: root equals: #foo:! !

!CMParserTest methodsFor: 'compatibility' stamp: 'cwp 6/15/2004 11:50'!
testAssignmentWithoutSpace
	| expr |
	expr _ self parseExpression: 'foo:=1'.
	self assert: expr statements first isAssignment.! !

!CMParserTest methodsFor: 'asserting' stamp: 'cwp 7/18/2004 12:24'!
assertAllParentsSet: root
	| nodes |
	nodes _ root isCollection
		ifTrue: [root]
		ifFalse: [CMPluggableVisitor root: root guide: CMPreOrderGuide new].
	nodes do: [:ea | self deny: ea root isNil] without: root! !

!CMParserTest methodsFor: 'bugs' stamp: 'cwp 6/1/2004 18:35'!
testGreaterThanAsParameter
	| root |
	root _ self parseExpression: 'Object assert: 1 > 0'.
	self assert: root isSequence.
	! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 7/18/2004 12:20'!
parse: aString with: aSelector
	| result |
	self 
		shouldnt: [result _ self parser perform: aSelector with: aString] 
		raise: SmaCCParserError.
	self assertAllParentsSet: result.
	^ result! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:31'!
parseExpression: aString
	^ self parse: aString with: #parseExpression:! !

!CMParserTest methodsFor: 'asserting' stamp: 'cwp 5/24/2004 14:38'!
assertLiteralExpression: root equals: value
	self assert: root isSequence.
	self assert: root statements first isLiteral.
	self assert: root statements first value = value
! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:23'!
testBlockWithArguments
	| root |
	root _ self parseExpression: '[:foo :bar | self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
	self assert: root statements first body isSequence.
	root statements first arguments 
						with: #(foo bar)
						do: [:arg :name | 
							self assert: arg isArgument.
							self assert: arg name = name]
							
! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 15:32'!
testNestedArrayLiteral
	self assertLiteralParses: #(1 2 (3 4 5))! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testMultiKeywordSymbolLiteral
	| root |
	root _ self parseExpression: '#foo:bar:'.
	self assertLiteralExpression: root equals: #foo:bar:! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:27'!
testUnaryMessage
	| root message |
	root _ self parseExpression: 'self foo'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isVariableReference.
	self assert: message selector = #foo.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testCascade2
	| root cascade |
	root _ self parseExpression: 'self foo; bar; baz'.
	cascade _ root statements first.
	self assert: cascade isCascade.
	self assert: cascade messages first selector = #foo.
	self assert: cascade messages second selector = #bar.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:22'!
testBareReturn
	| root |
	root _ self parseExpression: '^ 1'.
	self assert: root isSequence.
	self assert: root statements first isReturn.
	self assert: root statements first value isLiteral.
	self assert: root statements first value value = 1.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:22'!
testAssignment
	| root |
	root _ self parseExpression: 'var _ #value'.
	self assert: root statements first isAssignment.
	self assert: root statements first variable isVariableReference.
	self assert: root statements first value isValue.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testExpressionWithTemps
	| root |
	root _ self parseExpression: '| foo bar | foo _ 2. bar _ 3. foo + bar'.
	self assert: root isSequence.
	root temporaries with: #(foo bar) do: [:temp :name |
						self assert: (temp isVariableReference).
						self assert: (name = temp name)].
	self assert: root leftBar isToken.
	self assert: root leftBar value = '|'.
	self assert: root rightBar isToken.
	self assert: root rightBar value = '|'.
	! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testCascade
	| root cascade |
	root _ self parseExpression: 'self foo; bar'.
	cascade _ root statements first.
	self assert: cascade isCascade.
	self assert: cascade messages first selector = #foo.
	self assert: cascade messages second selector = #bar.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:25'!
testKeywordMessage
	| root message |
	root _ self parseExpression: 'self add: 4 to: 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isVariableReference.
	self assert: message selector = #add:to:.
	self assert: message arguments first isLiteral.
	self assert: message arguments second isLiteral.! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:31'!
parseMethod: aString
	^ self parse: aString with: #parseMethod:! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:42'!
testNegativeNumberLiteral
	self assertLiteralParses: -13! !

!CMParserTest methodsFor: 'annotations' stamp: 'cwp 5/29/2004 23:34'!
testMultiPrim2
	| prims |
	prims _ self parseAnnotations: '<primitive: 1><primitive: 2>'.
	self assert: prims first isAnnotation.
	self assert: prims second isAnnotation.! !

!CMParserTest methodsFor: 'compatibility' stamp: 'cwp 6/15/2004 12:57'!
testNegativeWithSpace
	| expr |
	expr _ self parseExpression: '0 @ - 1'.
	self assert: expr statements first isMessage! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:24'!
testByteArrayLiteral
	| root |
	root _ self parseExpression: '#[1 2 3]'.
	self assertLiteralExpression: root equals: (ByteArray with: 1 with: 2 with: 3)! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:28'!
testMethodWithSplitAnnotations
	| root |
	root _ self parseMethod: '+ aNumber <primitive: 1> | foo bar | <primitive: 2> ^ foo + bar'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	self assert: root annotations second isAnnotation.
	self assert: root body leftBar isToken.
	self assert: root body rightBar isToken.
	self assert: root body isSequence.
	! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:21'!
testArray
	| root |
	root _ self parseExpression: '{1. self foo. 2}'.
	self assert: root statements first isArray.
	self assert: root statements first statements first isLiteral.
	self assert: root statements first statements second isMessage.
	self assert: root statements first statements third isLiteral.! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:22'!
testKeywordMethod
	| root |
	root _ self parseMethod: 'foo: anObject bar: object ^ anObject + object'.
	self assert: root isMethod.
	self assert: root selector = #foo:bar:! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:22'!
testBinaryMessage
	| root message |
	root _ self parseExpression: '3 + 4'.
	message _ root statements first.
	self assert: message isMessage.
	self assert: message receiver isLiteral.
	self assert: message selector = #+.
	self assert: message arguments first isLiteral.! !

!CMParserTest methodsFor: 'annotations' stamp: 'cwp 5/28/2004 06:26'!
testMultiPrim
	| prims |
	prims _ self parseAnnotations: '<primitive: 1> <primitive: 2>'.
	self assert: prims first isAnnotation.
	self assert: prims second isAnnotation.! !

!CMParserTest methodsFor: 'annotations' stamp: 'cwp 5/28/2004 06:25'!
testMultiKeywordPrim
	| prim |
	prim _ (self parseAnnotations: '<primitive: ''foo'' module: ''FooModule''>') first.
	self assert: prim selector = #primitive:module:.
	self assert: (prim arguments collect: [:ea | ea value]) = #('foo' 'FooModule').
	self assert: prim isAnnotation! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/30/2004 00:05'!
testBlock
	| root |
	root _ self parseExpression: '[self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:41'!
testArrayLiteral
	self assertLiteralParses: #(1 2 3)! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:22'!
testUnaryMethod
	| root |
	root _ self parseMethod: 'foo ^ #foo'.
	self assert: root isMethod.
	self assert: root selector = #foo! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testReturnWithStatements
	| root |
	root _ self parseExpression: 'self foo. self bar. ^ 1'.
	self assert: root isSequence.
	self assert: root statements third isReturn.
	self assert: root statements third value isLiteral.
	self assert: root statements third value value = 1.! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:42'!
testNumberLiteral
	self assertLiteralParses: 13! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:26'!
testMethodWithAnnotation
	| root |
	root _ self parseMethod: '+ aNumber <primitive: 1> ^ super + aNumber'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	self assert: root annotations first selector = #primitive:.
	self assert: root annotations first arguments first isLiteral.
	self assert: root annotations first arguments first value = 1.
	! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testStringLiteral
	| root |
	root _ self parseExpression: '''foo'''.
	self assertLiteralExpression: root equals: 'foo'! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testStringSymbolLiteral
	| root |
	root _ self parseExpression: '#''foo bar'''.
	self assertLiteralExpression: root equals: #'foo bar'! !

!CMParserTest methodsFor: 'asserting' stamp: 'cwp 5/28/2004 06:22'!
assertLiteralParses: value
	| root |
	root _ self parseExpression: value asString.
	self assertLiteralExpression: root equals: value! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/24/2004 14:41'!
testTrueLiteral
	self assertLiteralParses: true! !

!CMParserTest methodsFor: 'asserting' stamp: 'cwp 6/15/2004 11:32'!
assertExpressionIsIllegal: aString
	self
		should: [self parser parseExpression: aString]
		raise: SmaCCParserError! !

!CMParserTest methodsFor: 'compatibility' stamp: 'cwp 6/15/2004 11:33'!
testDoubleColon
	self assertExpressionIsIllegal: '#foo::'! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testSymbolLiteral
	| root |
	root _ self parseExpression: '#foo'.
	self assertLiteralExpression: root equals: #foo! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:26'!
testNilLiteral
	self assertLiteralParses: nil! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:23'!
testBlockWithTemps
	| root |
	root _ self parseExpression: '[:foo :bar | | baz quux | self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
	self assert: root statements first body isSequence.
	root statements first body temporaries 
						with: #(baz quux)
						do: [:arg :name | 
							self assert: arg isVariableReference.
							self assert: arg name = name]
							
! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:26'!
testMethodWithTempsAndAnnotation
	| root |
	root _ self parseMethod: '+ aNumber | foo bar | <primitive: 1> ^ foo + bar'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	! !

!CMParserTest methodsFor: 'expressions' stamp: 'cwp 5/28/2004 06:23'!
testBlockWithTemps2
	| root |
	root _ self parseExpression: '[:foo :bar || baz quux | self doSomething]'.
	self assert: root isSequence.
	self assert: root statements first isBlock.
	self assert: root statements first body isSequence.
	root statements first body temporaries 
						with: #(baz quux)
						do: [:arg :name | 
							self assert: arg isVariableReference.
							self assert: arg name = name]
							
! !

!CMParserTest methodsFor: 'parsing' stamp: 'cwp 5/28/2004 06:18'!
parser
	^ CMParser! !

!CMParserTest methodsFor: 'methods' stamp: 'cwp 5/29/2004 23:26'!
testMethodEmptyTempsAndAnnotation
	| root |
	root _ self parseMethod: 'foo: aNumber || <primitive: 1> ^ foo'.
	self assert: root isMethod.
	self assert: root annotations first isAnnotation.
	! !

TestCase subclass: #CMPreOrderGuideTest
	instanceVariableNames: 'nodes'
	classVariableNames: 'SelectorTable'
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 12:23'!
testAssignment
	self visit: 'foo _ 2'.
	self assertClassesVisited: {CMAssignment. CMLiteral. CMVariableReference. CMToken}! !

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 12:30'!
testMethod
	| node |
	node _ CMParser parseMethod: 'foo: aString bar: aNumber <foo: 1>  ^ aNumber asString'.
	self visit: node.
	self assertClassesVisited: {CMMethod. CMArgument. CMAnnotation. CMLiteral. CMSequence}! !

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 12:21'!
testTopHalf
	self visit: self bundle.
	self assertClassesVisited: {CMBundle.
							CMPackage.
							CMClass.
							CMInstanceVariable.
							CMSharedVariable.
							CMMethod.
							CMAnnotation}! !

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 12:20'!
testArray
	self visit: '{1. 2. 3.}'.
	self assertClassesVisited: {CMArray. CMLiteral. CMToken}! !

!CMPreOrderGuideTest methodsFor: 'visiting' stamp: 'cwp 6/18/2004 21:11'!
doesNotUnderstand: aMessage
	((aMessage selector beginsWith: 'visit') and: [aMessage arguments first isNode])
		ifTrue: [self visitedVia: aMessage selector withNode: aMessage arguments first]
		ifFalse: [super doesNotUnderstand: aMessage]! !

!CMPreOrderGuideTest methodsFor: 'running' stamp: 'cwp 6/18/2004 21:48'!
bundle
	^ CMBundle new
		addPackage: CMBogusResource current package;
		addPackage: CMBogusExtResource current package;
		yourself! !

!CMPreOrderGuideTest class methodsFor: 'as yet unclassified' stamp: 'cwp 8/6/2004 23:52'!
initialize
	SelectorTable := Dictionary new.
	SelectorTable
		at: CMAnnotation put: #visitAnnotation:;
		at: CMArgument put: #visitArgument:;
		at: CMArray put: #visitArray:;
		at: CMAssignment put: #visitAssignment:;
		at: CMBlock put: #visitBlock:;
		at: CMBundle put: #visitBundle:;
		at: CMCascade put: #visitCascade:;
		at: CMClass put: #visitClass:;
		at: CMClassSegment put: #visitClassSegment:;
		at: CMInstanceVariable put: #visitInstanceVariable:;
		at: CMLiteral put: #visitLiteral:;
		at: CMMessage put: #visitMessage:;
		at: CMMetaclassSegment put: #visitMetaclassSegment:;
		at: CMMethod put: #visitMethod:;
		at: CMPackage put: #visitPackage:;
		at: CMPoolImport put: #visitPoolImport:;
		at: CMReturn put: #visitReturn:;
		at: CMSequence put: #visitSequence:;
		at: CMSharedVariable put: #visitSharedVariable:;
		at: CMStatementList put: #visitStatementList:;
		at: CMToken put: #visitToken:;
		at: CMVariableReference put: #visitVariableReference:! !

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 12:44'!
testBlockNoArgs
	self visit: '[:foo :bar]'.
	self assertClassesVisited: {CMBlock. CMArgument. CMToken}! !

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 13:31'!
testReturn
	self visit: '^ 1'.
	self assertClassesVisited: {CMReturn. CMToken. CMLiteral}! !

!CMPreOrderGuideTest methodsFor: 'visiting' stamp: 'cwp 6/19/2004 11:39'!
visitedVia: aSelector withNode: aNode
	nodes at: aNode ifPresent: [:node | self signalFailure: 'Node visited twice'].
	nodes at: aNode put: aSelector.
	
	aNode parent isNil ifFalse: [self assert: (nodes keys includes: aNode parent)]! !

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 13:27'!
testCascade
	self visit: 'self foo; bar'.
	self assertClassesVisited: {CMCascade. CMMessage. CMVariableReference}! !

!CMPreOrderGuideTest class methodsFor: 'as yet unclassified' stamp: 'cwp 6/18/2004 22:28'!
resources
	^ Array with: CMBogusResource with: CMBogusExtResource
	! !

!CMPreOrderGuideTest methodsFor: 'asserting' stamp: 'cwp 6/19/2004 12:20'!
assertClassesVisited: aCollection
	self assert: (self visitedClasses includesAllOf: aCollection)! !

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 11:14'!
testSelectors
	self visit: self bundle.
	nodes keysAndValuesDo: [:node :sel | self assert: (SelectorTable at: node class) = sel].
! !

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 13:40'!
testVariableReference
	self visit: 'foo bar'.
	self assertClassesVisited: {CMVariableReference. CMToken}.
	self assertNodesIncludes: (CMToken bareValue: 'foo')! !

!CMPreOrderGuideTest methodsFor: 'testing' stamp: 'cwp 6/19/2004 13:36'!
testArgument
	| node |
	node _ CMParser parseMethod: 'foo: aString'.
	self visit: node.
	self assertClassesVisited: {CMMethod. CMArgument. CMSequence. CMToken}.
	self assertNodesIncludes: (CMToken value: 'aString').! !

!CMPreOrderGuideTest methodsFor: 'asserting' stamp: 'cwp 6/19/2004 13:36'!
assertNodesIncludes: aNode
	self assert: (nodes keys asArray includes: aNode)! !

!CMPreOrderGuideTest methodsFor: 'visiting' stamp: 'cwp 6/19/2004 11:34'!
visitedClasses
	^ nodes keys collect: [:ea | ea class]! !

!CMPreOrderGuideTest methodsFor: 'visiting' stamp: 'cwp 6/19/2004 13:15'!
visit: aNodeOrString
	| node |
	nodes _ IdentityDictionary new.
	node _ aNodeOrString isString
		ifTrue: [CMParser parseExpression: aNodeOrString]
		ifFalse: [aNodeOrString].
	CMPreOrderGuide guide: self through: node.
! !

TestCase subclass: #CMExtensionImportTest
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMExtensionImportTest methodsFor: 'convenience' stamp: 'cwp 8/12/2004 22:21'!
bogusBClassSeg
	^package segments detect: [:ea | ea isClassSegment and: [ea name = #BogusB]]! !

!CMExtensionImportTest methodsFor: 'convenience' stamp: 'cwp 8/12/2004 22:20'!
bogusAMetaclassSeg
	^package segments detect: [:ea | ea isMetaclassSegment and: [ea name = #BogusA]]! !

!CMExtensionImportTest methodsFor: 'testing' stamp: 'cwp 7/20/2004 14:02'!
testMetaclass
	| segment |
	segment := self bogusAMetaclassSeg.
	self assert: segment isMetaclassSegment.
	self assert: segment name = #BogusA! !

!CMExtensionImportTest methodsFor: 'testing' stamp: 'cwp 8/13/2004 22:06'!
testClass
	| segment |
	segment := self bogusAClassSeg.
	self assert: segment isClassSegment.
	self assert: segment isExtension.
	self assert: segment name = #BogusA.
	self assert: segment category = 'Bogus-Base'.
	self assert: segment comment = BogusInfo aComment.
	self deny: segment hasInstanceVariables.
	self deny: segment hasClassVariables.
	self deny: segment hasPoolImports! !

!CMExtensionImportTest methodsFor: 'testing' stamp: 'cwp 8/13/2004 22:06'!
testClass2
	| segment |
	segment := self bogusBClassSeg.
	self assert: segment isClassSegment.
	self assert: segment isExtension.
	self assert: segment name = #BogusB.
	self assert: segment category = 'Bogus-Base'.
	self deny: segment hasInstanceVariables.
	self deny: segment hasClassVariables.
	self deny: segment hasPoolImports! !

!CMExtensionImportTest methodsFor: 'convenience' stamp: 'cwp 8/12/2004 22:19'!
bogusAClassSeg
	^ package segments detect: [:ea | ea isClassSegment and: [ea name = #BogusA]]! !

!CMExtensionImportTest methodsFor: 'running' stamp: 'cwp 6/3/2004 06:57'!
setUp
	package _ CMBogusExtResource current package.! !

!CMExtensionImportTest class methodsFor: 'as yet unclassified' stamp: 'cwp 6/3/2004 06:54'!
resources
	^ Array with: CMBogusExtResource! !

!CMExtensionImportTest methodsFor: 'testing' stamp: 'cwp 7/20/2004 13:59'!
testMethod
	| method |
	method := self bogusAClassSeg methods first.
	self assert: method selector = #foo.
	self assert: method category = #bogusext! !

!CMExtensionImportTest methodsFor: 'testing' stamp: 'cwp 8/12/2004 22:24'!
testClassSideExtension
	| segment |
	segment _ self bogusAMetaclassSeg.
	self assert: segment isMetaclassSegment.
	self assert: segment methods size = 1.
	self assert: segment name = #BogusA.
	self deny: ((package segments collect: [:ea | ea name]) includes: #Metaclass)! !

TestCase subclass: #CMPrinterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/25/2004 02:24'!
testComment
	self assertMethodMatches: 'foo "this is a comment" ^ 1'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:29'!
testBlockWithTemps
	self assertExpressionMatches: ' [:a : b :c || foo bar | foo]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 13:16'!
testArray
	self assertExpressionMatches: ' {foo. var. brz}'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 6/19/2004 14:04'!
testInvisibleAnnotations
	self assertAnnotation: '<category: #other>' matches: ''! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/25/2004 02:38'!
assertTree: root matches: source
	| stream result |
	stream _ WriteStream on: (String new: source size).
	CMSourcePrinter print: root on: stream.
	result _ stream contents.
	self assert: result = source.! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:00'!
testAssignment1
	self assertExpressionMatches: 'foo _ bar'! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/25/2004 15:31'!
testKeywordMethod
	self assertMethodMatches: 'foo: one bar: two ^ two'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:04'!
testLiteral
	self assertExpressionMatches: '''foo'''! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:00'!
testAssignment2
	self assertExpressionMatches: 'foo := bar'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/25/2004 00:29'!
assertMethodMatches: source
	self assertTree: (CMParser parseMethod: source) matches: source
! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/26/2004 15:16'!
testMulitpleAnnotations
	self assertAnnotationMatches: '<primitive: 1> <primitive: 2>'! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/26/2004 12:20'!
testUnaryMethod
	self assertMethodMatches: 'foo ^ 1'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:02'!
testByteArray
	self assertExpressionMatches: '#[10 13]'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/26/2004 15:00'!
testPrimitive
	self assertAnnotationMatches: '<primitive: 1>'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 13:39'!
testBlock
	self assertExpressionMatches: ' [foo bar. baz]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:58'!
testCascade
	self assertExpressionMatches: 'foo bar; baz'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 02:29'!
testMessages
	self assertExpressionMatches: 'foo bar. blic razz: 3 zap: 4. zic + 2'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 13:53'!
testBlockArgs
	self assertExpressionMatches: ' [:a :b :c]'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 6/19/2004 14:02'!
assertAnnotationMatches: source
	self assertAnnotation: source matches: source! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 19:35'!
testParenthesis3
	self assertExpressionMatches: '(foo _ 1) bar'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 02:23'!
testReturn
	self assertMethodMatches: 'foo ^ 1'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 5/25/2004 00:30'!
assertExpressionMatches: source
	self assertTree: (CMParser parseExpression: source) matches: source
! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/25/2004 02:24'!
testTemps
	self assertMethodMatches: 'foo | glaz blech | ^ 1'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/29/2004 23:48'!
testAdjacentAnnotations
	self assertAnnotationMatches: '<primitive: 1><primitive: 2>'! !

!CMPrinterTest methodsFor: 'methods' stamp: 'cwp 5/26/2004 12:21'!
testBinaryMethod
	self assertMethodMatches: '+ other ^ 1'! !

!CMPrinterTest methodsFor: 'annotations' stamp: 'cwp 5/26/2004 15:12'!
testMultikeywordAnnotation
	self assertAnnotationMatches: '<primitive: ''foo'' module: ''bar''>'! !

!CMPrinterTest methodsFor: 'asserting' stamp: 'cwp 6/19/2004 14:00'!
assertAnnotation: source matches: expected
	| stream result |
	stream _ WriteStream on: (String new: source size).
	(CMParser parseAnnotations: source)
		do: [:ea | CMSourcePrinter print: ea on: stream].
	result _ stream contents.
	self assert: result = expected.! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:54'!
testParenthesis2
	self assertExpressionMatches: '([self doSomething] on: Error do: []) bar'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 16:02'!
testLiteralArray
	self assertExpressionMatches: '#(foo bar 1 2)'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 14:47'!
testBlockWithArgs
	self assertExpressionMatches: ' [:a :b :c | self so: a by: b see: c]'! !

!CMPrinterTest methodsFor: 'expressions' stamp: 'cwp 5/25/2004 15:33'!
testParenthesis
	self assertExpressionMatches: '(self foo: 1) bar'! !

TestCase subclass: #CMEnvironmentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMEnvironmentTest methodsFor: 'testing' stamp: 'cwp 6/7/2004 00:47'!
testMethod
	| node method |
	node _ self methodNode.
	CMEnvironment current installMethod: node.
	method _ self compiledMethod.
	self assert: method selector = node selector.
	self assert: (self classForMethod organization categoryOfElement: self methodSelector)
					= node category.
	CMEnvironment current removeMethod: node.
	self denyMethodExists! !

!CMEnvironmentTest methodsFor: 'constants' stamp: 'cwp 6/7/2004 15:59'!
imageClass
	^ Smalltalk at: self nameOfTestClass ifAbsent: [self signalFailure: 'BogusD not created']! !

!CMEnvironmentTest methodsFor: 'constants' stamp: 'cwp 6/7/2004 00:27'!
classForMethod
	^ BogusA! !

!CMEnvironmentTest class methodsFor: 'as yet unclassified' stamp: 'cwp 7/20/2004 14:05'!
isAbstract
	^ true! !

!CMEnvironmentTest methodsFor: 'constants' stamp: 'cwp 6/7/2004 00:28'!
methodSelector
	^ #installedByEnvironment! !

!CMEnvironmentTest methodsFor: 'constants' stamp: 'cwp 6/7/2004 16:00'!
nameOfTestClass
	^ #BogusD! !

!CMEnvironmentTest methodsFor: 'asserting' stamp: 'cwp 6/7/2004 16:01'!
assertVariables: vars matchNames: names
	vars with: names asArray do: [:ivar :name | self assert: ivar name = name].
! !

!CMEnvironmentTest methodsFor: 'testing' stamp: 'cwp 6/15/2004 13:27'!
testClass
	| node class |
	node _ self classNode.
	CMEnvironment current installClass: node.
	class _ self imageClass.
	self assert: class name = node name.
	self assertVariables: node instanceVariables matchNames: class instVarNames.
	self assertVariables: node classVariables matchNames: class classVarNames.
	self assertVariables: node poolImports matchNames: class poolDictionaryNames.
	self assert: ((PackageInfo named: 'Bogus') longNameOf: node category) = class category.
	CMEnvironment current removeClass: node.
	self deny: (Smalltalk hasClassNamed: self nameOfTestClass)
		
	! !

!CMEnvironmentTest methodsFor: 'constants' stamp: 'cwp 6/19/2004 13:50'!
methodNode
	^ (CMParser parseMethod: (self methodSelector, ' ^ true'))
		parent: (CMClass named: self classForMethod name);
		category: #other;
		yourself
! !

!CMEnvironmentTest methodsFor: 'constants' stamp: 'cwp 6/19/2004 14:33'!
classNode
	| package class |
	package _ CMPackage named: 'Bogus'.
	class _ (CMClass named: self nameOfTestClass) 
				superName: #Object;
				addInstanceVariable: (CMInstanceVariable named: 'firstIvar');
				addInstanceVariable: (CMInstanceVariable named: 'secondIvar');
				addClassVariable: (CMSharedVariable named: 'ClassVariable');
				addPoolImport: (CMPoolImport named: 'BogusPool');
				category: #Base;
				yourself.
	package addClass: class.
	^ class! !

!CMEnvironmentTest methodsFor: 'asserting' stamp: 'cwp 6/7/2004 00:45'!
denyMethodExists
	self deny: (self classForMethod selectors includes: self methodSelector)! !

!CMEnvironmentTest methodsFor: 'constants' stamp: 'cwp 6/7/2004 00:27'!
compiledMethod
	^ self classForMethod compiledMethodAt: self methodSelector! !

TestCase subclass: #CMPackageMirrorTest
	instanceVariableNames: 'info mirror'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodeModel-Tests'!

!CMPackageMirrorTest methodsFor: 'running' stamp: 'cwp 5/26/2004 16:33'!
setUp
	info _ PackageInfo hidden: 'Bogus'.
	mirror _ CMPackageMirror forInfo: info.
	! !

!CMPackageMirrorTest methodsFor: 'testing' stamp: 'cwp 5/26/2004 16:44'!
testCoreClasses
	self assert: mirror classes = info classes! !

!CMPackageMirrorTest methodsFor: 'testing' stamp: 'cwp 5/26/2004 16:37'!
testName
	self assert: mirror packageName = info packageName! !

!CMPackageMirrorTest methodsFor: 'testing' stamp: 'cwp 5/26/2004 19:46'!
testMethods
	| expected actual |
	expected _ info methods.
	actual _ mirror methods.
	self assert: actual size = expected size.
	self assert: (actual includesAllOf: expected)! !
CMAnnotation initialize!
CMChangeNotifier initialize!
CMPreOrderGuideTest initialize!
